'use strict';

var St = require('crypto');
var We = require('fs');
var path = require('path');
var promises = require('fs/promises');
var buffer = require('buffer');
var Pi = require('tty');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var St__default = /*#__PURE__*/_interopDefault(St);
var We__default = /*#__PURE__*/_interopDefault(We);
var Pi__default = /*#__PURE__*/_interopDefault(Pi);

function vr(){if(typeof self<"u")return self;if(typeof window<"u")return window;if(typeof global<"u")return global;if(typeof globalThis<"u")return globalThis;throw new Error("unable to locate global object")}function X(){let e=vr();return e._zeedGlobal==null&&(e._zeedGlobal={}),e._zeedGlobal}function Cr(e){return e===!0||e==="true"||e==="1"||typeof e=="number"&&e!==0?e="*":e===!1||e==="false"||e===0||e==="0"||e==null||e==="null"||e==="undefined"?e="":e=String(e),e}function Er(){return Cr(typeof process<"u"?process.env.ZEED??process.env.DEBUG:typeof localStorage<"u"?localStorage.zeed??localStorage.debug:"*")}function j(e=Er()){let t,n=[],r=[];if(!e)t=function(o){return !1};else if(e==="*")t=function(o){return !0};else {let o,i=e.split(/[\s,]+/),a=i.length;for(o=0;o<a;o++){if(!i[o])continue;let s=i[o].replace(/\*/g,".*?");s[0]==="-"?n.push(new RegExp(`^${s.substr(1)}$`)):r.push(new RegExp(`^${s}$`));}t=function(s){if(n.length===0&&r.length===0)return !0;let u,c;for(u=0,c=n.length;u<c;u++)if(n[u].test(s))return !1;for(u=0,c=r.length;u<c;u++)if(r[u].test(s))return !0;return !1};}return t.accept=r,t.reject=n,t.filter=e,t}function Ur(){return typeof process<"u"?process.env.ZEED_LEVEL??process.env.LEVEL??process.env.DEBUG_LEVEL:typeof localStorage<"u"?localStorage.zeed_level??localStorage.level??localStorage.debug_level:void 0}function Ke(e){if(e===!1)return ee;if(typeof e=="number")return e;if(typeof e=="string"){let t=jt[e.toLocaleLowerCase().trim()];if(t!=null)return t}return z}function G(e=Ur()){let t=Ke(e);return n=>n>=t}function be(e={}){let{level:t=void 0,filter:n=void 0}=e,r=j(n),o=G(t);return i=>{if(!o(i.level)||!r(i.name))return;let a=i.name?`[${i.name}]`:"";switch(i.level){case O:console.info(`I|*   ${a}`,...i.messages);break;case B:console.warn(`W|**  ${a}`,...i.messages);break;case $:console.error(`E|*** ${a}`,...i.messages);break;default:console.debug(`D|    ${a}`,...i.messages);break}}}var z=-1,q=0,O=1,B=2,$=3,we=4,ee=9007199254740991,jt={"*":z,a:z,all:z,d:q,dbg:q,debug:q,i:O,inf:O,info:O,w:B,warn:B,warning:B,e:$,err:$,error:$,fatal:we,off:ee,"-":ee};function Nt(e=""){let t=[be()],n=u=>!0,r=!1,o=a,i=!1;function a(u="",c){let f=Ke(c??z);function l(g,m){return f<=g?m:()=>{}}let p=l(q,(...g)=>{d({name:u,messages:g,level:q});});p.label=u,p.extend=function(g){return o(u?`${u}:${g}`:g)};let d=g=>{if(n(u))for(let m of t)m&&m(g);};return p.debug=l(q,(...g)=>{d({name:u,messages:g,level:q});}),p.info=l(O,(...g)=>{d({name:u,messages:g,level:O});}),p.warn=l(B,(...g)=>{d({name:u,messages:g,level:B});}),p.error=l($,(...g)=>{d({name:u,messages:g,level:$});}),p.fatal=l(we,(...g)=>{throw d({name:u,messages:g,level:we}),new Error(`${g.map(String).join(" ")}`)}),p.assert=l(we,(g,...m)=>{(g==null||typeof g=="number"&&isNaN(g)||!g)&&p.fatal(...m);}),p}function s(u="",c){let f=o(u,c);return i&&f.debug(`+++ init of logger "${u}" on level "${f.level}".`),f}return s.registerHandler=function(u){t.push(u);},s.setFilter=function(u){n=j(u);},s.setLock=(u=!0)=>r=u,s.setDebug=(u=!0)=>i=u,s.setHandlers=function(u=[]){o!==a&&(o=a),!r&&(t=[...u].filter(c=>typeof c=="function"));},s.level=z,s.setLogLevel=function(u=z){r||(s.level=u);},s.setFactory=function(u){r||(o=u);},s}var V;function Ye(e){let t=Nt();return e?e(t):t.setHandlers([be()]),t}function Qe(e){if(V==null)try{let t=X();t!=null?t?.logger==null?(V=Ye(e),t.logger=V):V=t.logger:V=Ye(e);}catch{V=Ye(e);}return V}function Vt(){if(V!=null)return V;try{let e=X();if(e?.logger!=null)return e.logger}catch{}}function M(e,t){return Qe()(e,t)}function Fr(...e){throw Vt()?.("assert")?.fatal(...e),new Error(`${e.map(String).join(" ")}`)}function Pr(e,...t){(e==null||typeof e=="number"&&isNaN(e)||!e)&&Fr(...t);}function Ht(e,...t){Pr(e,...t);}var Dr=(e,t)=>t instanceof Object&&!Array.isArray(t)?Object.keys(t).sort().reduce((n,r)=>(n[r]=t[r],n),{}):t;function Ki(e,t=void 0){return JSON.stringify(e,Dr,t)}function Sr(e,t){let n=[],r=[];return t==null&&(t=function(o,i){return n[0]===i?"[Circular ~]":`[Circular ~.${r.slice(0,n.indexOf(i)).join(".")}]`}),function(o,i){if(n.length>0){let a=n.indexOf(this);~a?n.splice(a+1):n.push(this),~a?r.splice(a,1/0,o):r.push(o),~n.indexOf(i)&&(i=t?.call(this,o,i));}else n.push(i);try{return e==null?i:e.call(this,o,i)}catch{}return String(i)}}function k(e,t,n,r){return JSON.stringify(e,Sr(t??void 0,r),n??void 0)}var Yi=k;function Rr(e){let t=unescape(encodeURIComponent(e)),n=t.length,r=new Uint8Array(n);for(let o=0;o<n;o++)r[o]=t.codePointAt(o)||0;return r}function Mr(e){let t=e.length,n="",r=0;for(;t>0;){let o=t<1e4?t:1e4,i=e.subarray(r,r+o);r+=o,n+=String.fromCodePoint.apply(null,i),t-=o;}return decodeURIComponent(escape(n))}var Te;function Gt(e){if(Te==null&&(Te=Rr,typeof TextEncoder<"u")){let t=new TextEncoder;Te=n=>t.encode(n);}return Te(e.normalize("NFC"))}var Le;function zt(e){if(Le==null&&(Le=Mr,typeof TextDecoder<"u")){let t=new TextDecoder("utf-8",{ignoreBOM:!0});Le=n=>t.decode(n);}return Le(e).normalize("NFC")}function E(e){return e instanceof ArrayBuffer?new Uint8Array(e):typeof e=="string"?Gt(e):e.length?new Uint8Array(e):e}function es(...e){let t=0,n=e.flat(1).map(i=>{let a=E(i);return t+=a.length,a}),r=new Uint8Array(t),o=0;for(let i of n)r.set(i,o),o+=i.length;return r}function Wt(e){if(typeof Buffer<"u")return Buffer.from(E(e)).toString("hex");let t="0123456789abcdef",n="";for(let r of [...E(e)])n+=t[r>>4]+t[r&15];return n}function qt(e){return Uint8Array.from(e.match(/.{1,2}/g).map(t=>parseInt(t,16)))}function le(e,t=!1){let n=E(e),r="";if(typeof Buffer<"u")r=Buffer.from(n).toString("base64");else {let o="";for(let i=0;i<n.byteLength;i++)o+=String.fromCharCode(n[i]);r=btoa(o);}return t?r.replaceAll("=",""):r}function ts(e){let t=E(e);if(typeof Buffer<"u")return Buffer.from(t).toString("base64url").replaceAll("=","");let n="";for(let r=0;r<t.byteLength;r++)n+=String.fromCharCode(t[r]);return btoa(n).replaceAll("+","-").replaceAll("/","_").replaceAll("=","")}function Ae(e){if(e=e.replaceAll("-","+").replaceAll("_","/"),typeof Buffer<"u"){let r=Buffer.from(e,"base64");return new Uint8Array(r.buffer,r.byteOffset,r.byteLength)}let t=atob(e),n=new Uint8Array(t.length);for(let r=0;r<t.length;r++)n[r]=t.charCodeAt(r);return n}function ns(e){return zt(Ae(e))}function Jt(e,t){if(e.byteLength!==t.byteLength)return !1;let n=E(e),r=E(t);for(let o=0;o<n.length;o++)if(n[o]!==r[o])return !1;return !0}function Xe(e){return Gt(k(e))}function et(e){return JSON.parse(zt(e))}function Zt(e,t){if(typeof e!="string")if(e instanceof ArrayBuffer&&e.byteLength!==void 0)e=String.fromCharCode.apply(String,[].slice.call(new Uint8Array(e)));else if(Array.isArray(e))e=String.fromCharCode.apply(String,e);else if(e.constructor===Uint8Array)e=String.fromCharCode.apply(String,[].slice.call(e));else return !1;t=t||16;let n=[],r="0123456789ABCDEF";for(let o=0;o<e.length;o+=t){let i=e.slice(o,Math.min(o+t,e.length)),a=`0000${o.toString(16)}`.slice(-4),s=i.split("").map(c=>{let f=c.charCodeAt(0);return ` ${r[(240&f)>>4]}${r[15&f]}`}).join("");s+="   ".repeat(t-i.length);let u=i.replace(/[\x00-\x1F\x20\x7F-\xA0\xAD]/g,".");u+=" ".repeat(t-i.length),n.push(`${a} ${s}  ${u}`);}return n.join(`
`)}var te;function Yt(){return te===void 0&&(te=(typeof TextDecoder>"u"?null:new TextDecoder("utf-8",{fatal:!0,ignoreBOM:!0}))??null,te&&te.decode(new Uint8Array).length===1&&(te=null)),te}var Xt="Unexpected end of array",en="Integer out of Range",tt=class{constructor(t){this.arr=t,this.pos=0;}};function Ue(e){return new tt(e)}function nt(e,t){let n=de(e.arr.buffer,e.pos+e.arr.byteOffset,t);return e.pos+=t,n}function ne(e){let t=0,n=1,r=e.arr.length;for(;e.pos<r;){let o=e.arr[e.pos++];if(t=t+(o&127)*n,n*=128,o<128)return t;if(t>Number.MAX_SAFE_INTEGER)throw new Error(en)}throw new Error(Xt)}function Fe(e){return nt(e,ne(e))}function pe(e){return e.arr[e.pos++]}function tn(e){let t=e.arr[e.pos]+(e.arr[e.pos+1]<<8);return e.pos+=2,t}function nn(e){let t=e.arr[e.pos]+(e.arr[e.pos+1]<<8)+(e.arr[e.pos+2]<<16)+(e.arr[e.pos+3]<<24)>>>0;return e.pos+=4,t}function rt(e){let t=e.arr[e.pos++],n=t&63,r=64,o=(t&64)>0?-1:1;if(!(t&128))return o*n;let i=e.arr.length;for(;e.pos<i;){if(t=e.arr[e.pos++],n=n+(t&127)*r,r*=128,t<128)return o*n;if(n>Number.MAX_SAFE_INTEGER)throw new Error(en)}throw new Error(Xt)}function Br(e){let t=ne(e);if(t===0)return "";{let n=String.fromCodePoint(pe(e));if(--t<100)for(;t--;)n+=String.fromCodePoint(pe(e));else for(;t>0;){let r=t<1e4?t:1e4,o=e.arr.subarray(e.pos,e.pos+r);e.pos+=r,n+=String.fromCodePoint.apply(null,o),t-=r;}return decodeURIComponent(escape(n))}}function Ee(e){let t=Yt();return t?t.decode(Fe(e)):Br(e)}function ot(e,t){let n=new DataView(e.arr.buffer,e.arr.byteOffset+e.pos,t);return e.pos+=t,n}function it(e){return ot(e,4).getFloat32(0,!1)}function $r(e){return ot(e,8).getFloat64(0,!1)}function Or(e){return ot(e,8).getBigInt64(0,!1)}var _r=[e=>{},e=>null,rt,it,$r,Or,e=>!1,e=>!0,Ee,e=>{let t=ne(e),n={};for(let r=0;r<t;r++){let o=Ee(e);n[o]=re(e);}return n},e=>{let t=ne(e),n=[];for(let r=0;r<t;r++)n.push(re(e));return n},Fe];function re(e){return _r[127-pe(e)](e)}function de(e,t,n){return new Uint8Array(e,t,n)}var st=class{constructor(){this.cpos=0,this.cbuf=new Uint8Array(100),this.bufs=[];}};function Se(){return new st}function at(e){let t=e.cpos;for(let n=0;n<e.bufs.length;n++)t+=e.bufs[n].length;return t}function Re(e){let t=new Uint8Array(at(e)),n=0;for(let r=0;r<e.bufs.length;r++){let o=e.bufs[r];t.set(o,n),n+=o.length;}return t.set(de(e.cbuf.buffer,0,e.cpos),n),t}function jr(e,t){let n=e.cbuf.length;n-e.cpos<t&&(e.bufs.push(de(e.cbuf.buffer,0,e.cpos)),e.cbuf=new Uint8Array(Math.max(n,t)*2),e.cpos=0);}function F(e,t){let n=e.cbuf.length;e.cpos===n&&(e.bufs.push(e.cbuf),e.cbuf=new Uint8Array(n*2),e.cpos=0),e.cbuf[e.cpos++]=t;}var sn=F;function an(e,t){F(e,t&255),F(e,t>>>8&255);}function un(e,t){for(let n=0;n<4;n++)F(e,t&255),t>>>=8;}function J(e,t){for(;t>127;)F(e,128|127&t),t=Math.floor(t/128);F(e,127&t);}function Nr(e){return e!==0?e<0:1/e<0}function ut(e,t){let n=Nr(t);for(n&&(t=-t),F(e,(t>63?128:0)|(n?64:0)|63&t),t=Math.floor(t/64);t>0;)F(e,(t>127?128:0)|127&t),t=Math.floor(t/128);}function Me(e,t){let n=e.cbuf.length,r=e.cpos,o=Math.min(n-r,t.length),i=t.length-o;e.cbuf.set(t.subarray(0,o),r),e.cpos+=o,i>0&&(e.bufs.push(e.cbuf),e.cbuf=new Uint8Array(Math.max(n*2,i)),e.cbuf.set(t.subarray(o)),e.cpos=i);}function ke(e,t){J(e,t.byteLength),Me(e,t);}function Hr(e,t){let n=unescape(encodeURIComponent(t)),r=n.length;J(e,r);for(let o=0;o<r;o++)F(e,n.codePointAt(o));}function De(e,t){return Hr(e,t)}function ct(e,t){jr(e,t);let n=new DataView(e.cbuf.buffer,e.cpos,t);return e.cpos+=t,n}function lt(e,t){return ct(e,4).setFloat32(0,t,!1)}function Gr(e,t){return ct(e,8).setFloat64(0,t,!1)}function zr(e,t){return ct(e,8).setBigInt64(0,t,!1)}var Pe;function Wr(e){return Pe==null&&(Pe=new DataView(new ArrayBuffer(4))),Pe.setFloat32(0,e),Pe.getFloat32(0)===e}function ie(e,t){switch(typeof t){case"string":F(e,119),De(e,t);break;case"number":Number.isInteger(t)&&Math.abs(t)<=2147483647?(F(e,125),ut(e,t)):Wr(t)?(F(e,124),lt(e,t)):(F(e,123),Gr(e,t));break;case"bigint":F(e,122),zr(e,t);break;case"object":if(t===null)F(e,126);else if(Array.isArray(t)){F(e,117),J(e,t.length);for(let n=0;n<t.length;n++)ie(e,t[n]);}else if(t instanceof Uint8Array)F(e,116),ke(e,t);else {F(e,118);let n=Object.keys(t);J(e,n.length);for(let r=0;r<n.length;r++){let o=n[r];De(e,o),ie(e,t[o]);}}break;case"boolean":F(e,t?120:121);break;default:F(e,127);}}var cn=class{async encode(t){let n=Se();return ie(n,t),Re(n)}async decode(t){return re(Ue(E(t)))}};function bs(e){let t=Se();return ie(t,e),Re(t)}function ws(e){return re(Ue(E(e)))}function Ts(e){let t=Se();return e!=null&&Me(t,E(e)),{writeBytes:(n,r)=>{let o=E(n);Ht(!(r!=null&&o.length!==r),`Expected ${r} bytes, got ${o.length}`),Me(t,o);},writeBytesVar:n=>ke(t,E(n)),writeUintVar:n=>J(t,n),writeUint8:n=>sn(t,n),writeUint16:n=>an(t,n),writeUint32:n=>un(t,n),writeIntVar:n=>ut(t,n),writeFloat:n=>lt(t,n),writeStringVar:n=>De(t,n),write:n=>ie(t,n),getUint8Array:()=>Re(t),getLength:()=>at(t)}}function Ls(e){let t=Ue(E(e));return {readBytes:n=>nt(t,n),readBytesVar:()=>Fe(t),readUintVar:()=>ne(t),readUint8:()=>pe(t),readUint16:()=>tn(t),readUint32:()=>nn(t),readIntVar:()=>rt(t),readFloat:()=>it(t),readStringVar:()=>Ee(t),read:()=>re(t),getOffset:()=>t.pos||0}}function As(e=0){return {setBit:(t,n=!0)=>n?e|=1<<t:e&=~(1<<t),unsetBit:t=>e&=1<<t,toggleBit:t=>e^=1<<t,getBit:t=>(e&1<<t)!==0,getValue:()=>e}}async function qr(e){return await e.arrayBuffer()}async function vs(e){let t=await qr(e);if(t!=null)return E(t)}function se(e=16){let t=new Uint8Array(e);if(typeof crypto<"u"&&crypto.getRandomValues)crypto.getRandomValues(t);else for(let n=0;n<e;n++)t[n]=Math.floor(Math.random()*256);return t}var fn="SHA-256",ft="AES-GCM",ln="PBKDF2",Jr=1e5;async function Us(e,t=fn){return E(await crypto.subtle.digest(t,E(e)))}async function Fs(e,t={}){let n=E(e),r=await crypto.subtle.importKey("raw",n,ln,!1,["deriveKey"]);return await crypto.subtle.deriveKey({name:ln,salt:t.salt?E(t.salt):new Uint8Array(0),iterations:t.iterations??Jr,hash:fn},r,{name:ft,length:256},!0,["encrypt","decrypt"])}function pn(){return new Uint8Array([1,1])}async function dn(e,t){let n=pn(),r=se(12),o=await crypto.subtle.encrypt({name:ft,iv:r},t,e),i=new Uint8Array(o),a=n.length+r.length+i.length,s=new Uint8Array(a),u=0;return s.set(n,u),u+=n.length,s.set(r,u),u+=r.length,s.set(i,u),s}async function gn(e,t){let n=e.subarray(0,2);if(!Jt(n,pn()))return Promise.reject(new Error(`Unknown magic ${n}`));let r=e.subarray(2,2+12),o=e.subarray(2+12,e.length),i=await crypto.subtle.decrypt({name:ft,iv:r},t,o);return new Uint8Array(i)}function Zr(){return crypto.getRandomValues(new Uint32Array(1))[0]/4294967295}function D(){return typeof crypto<"u"?Zr():Math.random()}function Ds(e=.25){return D()<e}function Ss(e=100,t=0){return t+Math.floor(D()*(e-t))}function Rs(e=100,t=0){return t+D()*(e-t)}function Ms(e,t,n){return Math.max(e,Math.min(n,t))}function Kr(e){return e.reduce((t,n)=>t+n,0)}function ks(e){return Kr(e)/e.length}function Is(e){return !/^1?$|^(11+?)\1+$/.test("1".repeat(e))}function Bs(e){for(let t=2;t<e;t++)if(e%t===0)return !1;return e>1}var pt=6;function $s(e=0,t=1,n){pt=((n??pt)*9301+49297)%233280;let r=pt/233280;return t+r*(e-t)}function Yr(e=""){let[t="",n="asc"]=e.split(" ");return n=n.toLowerCase(),{field:t,orderby:n,asc:n!=="desc",desc:n==="desc"}}function _s(e,t=!0){return `${e} ${t?"asc":"desc"}`}function dt(e,t,n=!0){let r=e||0,o=t||0;return r>o?n?1:-1:r<o?n?-1:1:0}function js(e,...t){if(t.length>0){let n=t.map(Yr),r=Array.from(e);return r.sort((o,i)=>{for(let{field:a,asc:s}of n){let u=dt(o[a],i[a],s);if(u!==0)return u}return 0}),r}return e}function gt(e){return e.filter((t,n)=>e.indexOf(t)===n)}function Qr(e,t){return gt(e.filter(n=>!t.includes(n)))}function Xr(...e){return gt(e.reduce((t=[],n)=>t.concat(n),[]))}function ae(...e){return e.flat(1/0)}function eo(e,t){return gt(e).filter(n=>t.includes(n))}function Gs(e,t){return Qr(Xr(e,t),eo(e,t))}function mn(e,t){if(e&&Array.isArray(e)){let n;for(;(n=e.indexOf(t))!==-1;)e.splice(n,1);return e}return []}function zs(e,t){return e.includes(t)||e.push(t),e}function mt(e,t){return e.splice(0,e.length,...e.filter(t)),e}function Ws(e,t){let n=e.findIndex(r=>r===t);return n>=0?e.splice(n,1):e.push(t),e}function qs(e){return e.splice(0,e.length),e}function to(e,t=dt){return Array.from(e).sort(t)}function Js(e){return to(e,(t,n)=>t-n)}function no(e,t){return e.length===t.length&&e.every((n,r)=>n===t[r])}function yn(e){return e.sort(()=>D()>.5?1:-1),e}function Zs(e){return yn(Array.from(e))}function Ks(e){for(;e.length>1;){let t=Array.from(e);if(yn(t),!no(e,t))return t}return e}function Ys(e){return e[Math.floor(D()*e.length)]}function Qs(...e){return ae(e).reduce((t,n)=>t!=null?n>t?n:t:n,void 0)}function Xs(...e){return ae(e).reduce((t,n)=>t!=null?n<t?n:t:n,void 0)}function ea(...e){return ae(e).reduce((t,n)=>t+n,0)}function ta(...e){let t=ae(e);return t.reduce((n,r)=>n+r,0)/t.length}function na(e,t){let n=[],r=0,o=e.length;for(;r<o;)n.push(e.slice(r,r+=t));return n}function ra(e=0,t){if(e<=0)return [];let n=new Array(e);for(let r=0;r<e;r++)n[r]=t instanceof Function?t(r):t;return n}var ro={2:"01",8:"01234567",11:"0123456789a",16:"0123456789abcdef",32:"0123456789abcdefghjkmnpqrtuvwxyz","32-crockford":"0123456789ABCDEFGHJKMNPQRSTVWXYZ","32-geohash":"0123456789bcdefghjkmnpqrstuvwxyz","32-agnoster":"0123456789abcdefghjkmnpqrtuvwxyz","32-rfc":"ABCDEFGHIJKLMNOPQRSTUVWXYZ234567","32-hex":"0123456789ABCDEFGHIJKLMNOPQRSTUV","32-zbase":"ybndrfg8ejkmcpqxot1uwisza345h769",36:"0123456789abcdefghijklmnopqrstuvwxyz",58:"123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz",62:"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz",64:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/","64-url":"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_",66:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_.!~",85:"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz!#$%&()*+-;<=>?@^_`{|}~"};function oo(e){let t=ro[String(e)];if(!t)if(typeof e=="string")t=e;else throw new Error(`Unknown base ${e}`);if(t.length>=255)throw new TypeError("Alphabet too long");let n=new Uint8Array(256);for(let c=0;c<n.length;c++)n[c]=255;for(let c=0;c<t.length;c++){let f=t.charAt(c),l=f.charCodeAt(0);if(n[l]!==255)throw new TypeError(`${f} is ambiguous`);n[l]=c;}let r=t.length,o=t.charAt(0),i=Math.log(r)/Math.log(256),a=Math.log(256)/Math.log(r);function s(c,f=-1){let l=E(c);if(l.byteLength===0)return "";let p=0,d=0,g=l.byteLength;for(;d!==g&&l[d]===0;)d++;let m=(g-d)*a+1>>>0,b=new Uint8Array(m);for(;d!==g;){let v=l[d],U=0;for(let h=m-1;(v!==0||U<p)&&h!==-1;h--,U++)v+=256*b[h]>>>0,b[h]=v%r>>>0,v=v/r>>>0;if(v!==0)throw new Error("Non-zero carry");p=U,d++;}let y=m-p;for(;y!==m&&b[y]===0;)y++;let T="";for(;y<m;++y)T+=t.charAt(b[y]);return f>0?T.padStart(f,o):T}function u(c,f=-1){if(typeof c!="string")throw new TypeError("Expected String");if(c.length===0)return new Uint8Array;c=c.replace(/\s+/gi,"");let l=0,p=0;for(;c[l]===o;)l++;let d=(c.length-l)*i+1>>>0,g=new Uint8Array(d);for(;c[l];){let b=n[c.charCodeAt(l)];if(b===255)throw new Error(`Unsupported character "${c[l]}"`);let y=0;for(let T=d-1;(b!==0||y<p)&&T!==-1;T--,y++)b+=r*g[T]>>>0,g[T]=b%256>>>0,b=b/256>>>0;if(b!==0)throw new Error("Non-zero carry");p=y,l++;}let m=d-p;for(;m!==d&&g[m]===0;)m++;return f>0?new Uint8Array([...new Uint8Array(f-g.length+m),...g.slice(m)]):g.slice(m)}return {encode:s,decode:u}}var Ie;function W(e){Ie==null&&(Ie=new Map);function t(){let o=Ie.get(e);return o==null&&(o=oo(e),Ie.set(e,o)),o}function n(o,i=-1){return t().encode(o,i)}function r(o,i=-1){return t().decode(o,i)}return {encode:n,decode:r}}function yt(e,t=-1){return W(32).encode(e,t)}function hn(e,t=-1){return W(32).decode(e.toLocaleLowerCase().replaceAll("l","1").replaceAll("s","5").replaceAll("o","0").replaceAll("i","1"),t)}function sa(e,t=-1){return W(16).encode(e,t)}function aa(e,t=-1){return W(16).decode(e,t)}function ua(e,t=-1){return W(58).encode(e,t)}function ca(e,t=-1){return W(58).decode(e,t)}function ht(e,t=-1){return W(62).encode(e,t)}function xn(e,t=-1){return W(62).decode(e,t)}function la(e,t){return Math.ceil(e*(Math.log(256)/Math.log(t)))}function bn(e){return e.length>0&&(/^[A-Z0-9_\-\ ]*$/g.test(e)&&(e=e.toLowerCase()),e=e.replace(/^[-_\ ]+/gi,"").replace(/[-_\ ]+$/gi,"").replace(/[-_\ ]+([a-z0-9])/gi,(t,n)=>n.toUpperCase()),e=e[0].toLowerCase()+e.substring(1)),e}function io(e){return e.charAt(0).toUpperCase()+e.toLowerCase().slice(1)}function pa(e){return e.replace(/\w\S*/g,io)}function da(e,t="-"){return t=typeof t>"u"?"_":t,e.replace(/([a-z\d])([A-Z])/g,`$1${t}$2`).replace(/([A-Z]+)([A-Z][a-z\d]+)/g,`$1${t}$2`).toLowerCase()}var wn=["1","true","yes","y","on"];function ya(e,t=!1){return e==null||typeof e!="string"?t:wn.includes(String(e).trim().toLowerCase())}function ha(e,t=0){return e==null||typeof e!="string"?t:parseInt(e.trim(),10)??t}function xa(e,t=0){return e==null||typeof e!="string"?t:parseFloat(e.trim())??t}function Z(e,t=!1){return e==null?t:typeof e=="boolean"?e:typeof e=="number"?e!==0:wn.includes(String(e).trim().toLowerCase())}function so(e,t=0){return e==null?t:typeof e=="boolean"?e?1:0:typeof e=="number"?Math.floor(e):parseInt(String(e).trim(),10)??t}function ao(e,t=0){return e==null?t:typeof e=="boolean"?e?1:0:typeof e=="number"?Math.floor(e):parseFloat(String(e).trim())??t}function xt(e,t=""){return e==null?t:String(e)??t}var ba=ao,wa=so,Ta=xt,La=Z;function uo(e,t={}){let{trace:n=!0,pretty:r=!0}=t;return e.map(o=>{if(o&&typeof o=="object"){if(r&&(o instanceof Uint8Array||o instanceof ArrayBuffer))return `
${Zt(o)}
`;if(o instanceof Error)return n?`${o.name||"Error"}: ${o.message}
${o.stack}`:`${o.name||"Error"}: ${o.message}`;try{return r?JSON.stringify(o,null,2):JSON.stringify(o)}catch{}}return String(o)})}function Be(e,t={}){return uo(e,t).join(" ")}function Aa(e){try{return decodeURIComponent(escape(e))}catch{}return e}function Ea(e){if(e.startsWith("data:"))return Ae(e.split(",",2)[1])}function Ua(e){if(e.startsWith("data:"))return e.slice(5).split(",",2)[0]}function Fa(e){if(e.startsWith("data:")){let[t,n]=e.slice(5).split(",",2);return new Blob([Ae(n)],{type:t})}}async function Pa(e){let t=await e.arrayBuffer();if(t)return `data:${e.type},${le(t)}`}function Da(e,t="application/octet-stream"){return `data:${t},${le(e)}`}var Tn=864e5;function wt(e){return Math.floor(e/1e4)}function Ln(e){return Math.floor(e/100%100)}function co(e){return Math.floor(e%100)}function Ra(e){return [wt(e),Ln(e),co(e)]}function An(e,t=!1){return t?new Date(`${fo(e)}T00:00:00.000Z`):new Date(e/1e4,e/100%100-1,e%100)}function vn(){return Oe(new Date)}function Ma(e,t=!1){if(typeof e=="number")return e<100?void 0:e;if(typeof e=="string")return Cn(e);if(Array.isArray(e)&&e.length===3){let[n,r,o]=e;return Tt(n,r,o)}else if(e instanceof Date)return Oe(e,t)}function ka(e){return An(e,!0)}function Oe(e,t=!1){return t?Cn(e.toISOString()):e.getFullYear()*1e4+(e.getMonth()+1)*100+e.getDate()}function Ia(e){return Oe(e,!0)}function bt(e,t=!0){return An(e,t).getTime()}function lo(e,t=!0){return Oe(new Date(e),t)}function fo(e,t="-"){let n=String(e);return n.slice(0,4)+t+n.slice(4,6)+t+n.slice(6,8)}function Tt(e,t=1,n=1){if(!(t<1||t>12||n<1||n>31))return e*1e4+t*100+n}function Cn(e){let t=String(e).replace(/[^0-9]/g,"").slice(0,8);if(t.length===8)return +t}function Ba(e,t=0){let n=wt(e),r=Ln(e);return t!==0&&(r+=t,n+=Math.floor((r-1)/12),r=Math.floor((r-1)%12)+1,r===0&&(r=12)),Tt(n,r,1)}function $a(e,t=0){let n=wt(e);return Tt(n+t,1,1)}function $e(e,t){return lo(bt(e)+t*864e5)}function Oa(e,t){return Math.round((bt(t)-bt(e))/864e5)}function _a(e,t){let n=[];for(t==null&&(t=vn()),e<0&&(e=$e(t,e+1));e<=t;)n.push(e),e=$e(e,1);return n}function*ja(e,t){let n=[];for(t==null&&(t=vn()),e<0&&(e=$e(t,e+1));e<=t;)yield e,e=$e(e,1);return n}function En(){let e,t;return [new Promise((r,o)=>{e=r,t=o;}),e,t]}async function Va(e){return new Promise(t=>setTimeout(t,e))}async function Ha(){return new Promise(e=>setTimeout(e,0))}async function Ga(e,t,n="timeoutReached"){return new Promise(async(r,o)=>{let i=!1,a=setTimeout(()=>{i=!0,r(n);},t);try{let s=await e;clearTimeout(a),i||r(s);}catch(s){clearTimeout(a),i||o(s);}})}function za(e){return e==="timeoutReached"||e?.name==="Timeout reached"}async function Un(e,t){return t<=0?await e:new Promise(async(n,r)=>{let o=!1,i=setTimeout(()=>{o=!0,r(new Error("Timeout reached"));},t);try{let a=await e;clearTimeout(i),o||n(a);}catch(a){clearTimeout(i),o||r(a);}})}function Wa(e,t,n=1e3){return new Promise((r,o)=>{let i=u=>{s&&(clearTimeout(s),a(),r(u));},a=()=>{s=null,e.off?e.off(t,i):e.removeEventListener&&e.removeEventListener(t,i);},s=setTimeout(()=>{a(),o(new Error("Did not response in time"));},n);e.on?e.on(t,i):e.addEventListener&&e.addEventListener(t,i);})}function S(e){return !!(e&&(e instanceof Promise||typeof e.then=="function"))}function me(e){return Promise.resolve(e)}var A=class{get value(){return this.days}constructor(t){if(typeof t=="number"){this.days=t;return}if(t!=null&&(t=A.from(t)?.days),t==null){let n=new Date;this.days=n.getFullYear()*1e4+(n.getMonth()+1)*100+n.getDate();}else this.days=t;}static fromNumber(t){return new A(t)}static fromString(t){return A.from(+t.replace(/[^0-9]/g,"").slice(0,8))}static fromDate(t,n=!1){return n?A.fromString(t.toISOString().substr(0,10)):A.from(t.getFullYear()*1e4+(t.getMonth()+1)*100+t.getDate())}static fromDateGMT(t){return A.fromDate(t,!0)}static from(t,n=!1){if(typeof t=="number")return t<100?void 0:new A(t);if(typeof t=="string")return A.fromString(t);if(Array.isArray(t)&&t.length===3){let[r,o=1,i=1]=t;return o<1||o>12||i<1||i>31?void 0:new A(r*1e4+o*100+i)}else {if(t instanceof Date)return A.fromDate(t,n);if(t instanceof A)return t}}toNumber(){return this.days}toJson(){return this.days}toString(t="-"){let n=String(this.days);return n.slice(0,4)+t+n.slice(4,6)+t+n.slice(6,8)}toDate(t=!1){return t?new Date(`${this.toString()}T00:00:00.000Z`):new Date(this.days/1e4,this.days/100%100-1,this.days%100)}toDateGMT(){return this.toDate(!0)}get year(){return Math.floor(this.days/1e4)}get month(){return Math.floor(this.days/100%100)}get day(){return Math.floor(this.days%100)}dayOffset(t){return A.fromDateGMT(new Date(this.toDateGMT().getTime()+t*864e5))}monthStart(){return A.from([this.year,this.month,1])}yearStart(){return A.from([this.year,1,1])}monthOffset(t){let n=this.month+t,r=Math.floor((n-1)%12)+1;r===0&&(r=12);let o=Math.floor((n-1)/12);return A.from([this.year+o,r,this.day])}daysUntil(t){return Math.round((new A(t)?.toDateGMT().getTime()-this.toDateGMT().getTime())/864e5)}yesterday(){return this.dayOffset(-1)}tomorrow(){return this.dayOffset(1)}};async function Za(e,t,n){let r=A.from(e),o=A.from(t);for(;r&&o&&r?.days<=o?.days;){let i=n(r);S(i)&&await i,r=r.dayOffset(1);}}function Ka(){return new A}function Ya(e){return new A(e)}function Qa(e){return A.fromDate(new Date(e)).days}function po(e,t=2){return +(+e).toFixed(t)}function eu(e,t=2){return +(+e/10**t).toFixed(t)}function tu(e,t=2){return Math.round(+e*10**t)}function nu(e,t=2){return t*(po(e,t)%1)}function iu(e,t,n){let r=e[t];return r===void 0&&(r=n(t,e),e[t]=r),r}async function su(e,t,n){let r=e[t];return r===void 0&&(r=await n(t,e),e[t]=r),r}function Fn(e){return e!=null?e.size!=null?e.size:e.length!=null?e.length:Object.keys(e).length:0}function au(e){return e!=null&&e.length>0?e[0]:void 0}function uu(e){return e!=null&&e.length>0?e[e.length-1]:void 0}function cu(e){try{if(e!=null)return Array.isArray(e)||typeof e=="string"?e.length<=0:e?.size!=null?e.size<=0:Object.keys(e).length<=0}catch(t){console.warn("Failed to check if empty for",e,t);}return !0}function ue(e){return Object(e)!==e?e:JSON.parse(k(e))}function lu(e){return Object(e)!==e?e:JSON.parse(k(e))}function fu(e){let t=new Map;return n=>{if(t.has(n))return t.get(n);let r=e(n);return t.set(n,r),r}}function pu(e){let t=new Map;return async(...n)=>{let r=k(n);if(t.has(r))return t.get(r);let o=await e(...n);return t.set(r,o),o}}function du(e,t){let n=[];for(let r=0;r<e;r++)n.push(t(r,e));return n}function N(e){return e!=null&&typeof e=="object"}function Lt(e){return Object(e)!==e}function H(e){return Array.isArray(e)}function _e(e){return N(e)&&!H(e)}function yu(e){return e?.constructor===Object}function Pn(e){return typeof e=="string"}function Dn(e){return typeof e=="number"&&!isNaN(e)}function hu(e){return Dn(e)&&Number.isInteger(e)}function xu(e){return Dn(e)&&Number.isSafeInteger(e)}function Sn(e){return typeof e=="boolean"}function bu(e){return e==null}function wu(e){return e==null}function Tu(e){return N(e)&&e.constructor.name==="Uint8Array"}function Rn(e){return e!=null}function go(e){return e==null||e===""||N(e)&&Fn(e)<=0}function Lu(e){return !go(e)}function Au(e){return e!=null&&e!==!1&&e!==!0}function vu(e){return e!=null&&e!==!1&&e!==0&&e!==""}function mo(e,t,n=new WeakSet){if(e===t)return !0;if(n.has(t)||(Lt(t)||n.add(t),!(e instanceof Object)||!(t instanceof Object))||e.constructor!==t.constructor||e.length!==t.length)return !1;for(let r in e){if(!e.hasOwnProperty(r))continue;if(!t.hasOwnProperty(r))return !1;let o=e[r],i=t[r];if(!mo(o,i,n))return !1}for(let r in t)if(t.hasOwnProperty(r)&&!e.hasOwnProperty(r))return !1;return !0}function yo(e,t=new WeakSet){if(t.has(e))return "[Circular ~]";if(Lt(e)||t.add(e),_e(e)){for(let n in e)if(e.hasOwnProperty(n)){if(e[n]===void 0){delete e[n];continue}yo(e[n],t);}}else if(H(e))for(let n=e.length-1;n>=0;n--)e[n]===void 0&&e.splice(n,1);return e}function je(e,...t){for(let n of t)N(e)||(e={}),!(n==null||!N(n))&&Object.keys(n).forEach(r=>{let o=e[r],i=n[r];Array.isArray(o)&&Array.isArray(i)?e[r]=o.concat(i):N(o)&&N(i)?e[r]=je(Object.assign({},o),i):e[r]=i;});return e}function ho(e,t,n={cyclesFix:!0},r=[]){let o=[],i=Array.isArray(e);for(let s in e){let u=e[s],c=i?+s:s;if(!(s in t)){o.push({type:"del",path:[c]});continue}let f=t[s],l=typeof u=="object"&&typeof f=="object";if(u&&f&&l&&!["Date","RegExp","String","Number"].includes(Object.getPrototypeOf(u).constructor.name)&&(!n.cyclesFix||!r.includes(u))){let p=ho(u,f,n,n.cyclesFix?r.concat([u]):[]);o=[...o,...p.map(d=>(d.path.unshift(c),d))];}else u!==f&&!(l&&(isNaN(u)?`${u}`==`${f}`:+u==+f))&&o.push({path:[c],type:"upd",value:f});}let a=Array.isArray(t);for(let s in t)s in e||o.push({type:"new",path:[a?+s:s],value:t[s]});return o}function Mn(e){return e.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/'/g,"&apos;").replace(/"/g,"&quot;")}function Pu(e){return e.replace(/&lt;/gi,"<").replace(/&gt;/gi,">").replace(/&quot;/gi,'"').replace(/&apos;/gi,"'").replace(/&amp;/gi,"&")}function Su(e,t,n=[]){return e.filter(r=>!t.some(o=>!o(r))).map(r=>{for(let o of n)r=o(r);return r}).filter(r=>r!=null)}function Ru(e,t){return e.reduce((n,r)=>{let o=String(r[t]);return (n[o]=n[o]||[]).push(r),n},{})}function Mu(e,t){return Array.from(e.reduce((n,r)=>n.add(r[t]),new Set))}function ku(e,t){return e.map(n=>n[t])}function $u(e,t){return N(e)?Object.fromEntries(Object.entries(e).map(([n,r])=>{let o=t(n,r);return H(o)&&o.length===2?o:[n,o]}).filter(n=>n!=null)):{}}function Ou(e,t){return t.dispose&&e.dispose&&t.dispose.add(e.dispose),Object.assign(e,t)}function _u(e){return Object.keys(e).length<=0}var xo=/[\\\-\[\]\/{}()*+?.^$|]/g;function Ne(e){return e?e instanceof RegExp?e.source:e.replace(xo,"\\$&"):""}var bo=100,wo=/^\.+/,To=/\.+$/,Lo=/[<>:\"/\\|?*\u0000-\u001F\u0080-\u009F]+/gm;function kn(){return Lo}function Ao(){return /^(con|prn|aux|nul|com\d|lpt\d)$/i}function In(e,t="_"){if(typeof e!="string")throw new TypeError("Expected a string");if(kn().test(t))throw new Error("Replacement string cannot contain reserved filename characters");let n=`(${Ne(t)})+`;return e=e.replace(kn(),t).replace(wo,t).replace(To,"").replace(new RegExp(n,"gm"),t).trim(),e=Ao().test(e)?e+t:e,e.slice(0,bo)}function ye(e){return Math.abs(e)%1===.5}function Bn(e){return e%2===0}var Gu=e=>Math.ceil(e),zu=e=>Math.floor(e),Wu=e=>Math.round(e),qu=e=>{let t=Math.round(e);return ye(e)&&Bn(t)?t-1:t},Ju=e=>ye(e)?Math.sign(e)*Math.ceil(Math.abs(e)):Math.round(e),Zu=e=>ye(e)?Math.floor(e):Math.round(e),Ku=e=>{let t=Math.round(e);return ye(e)?Bn(t)?t:t-1:t},Yu=e=>ye(e)?Math.sign(e)*Math.floor(Math.abs(e)):Math.round(e);function $n(e){return e.reduce((t,n)=>Math.min(t,n.sort_weight||0),0)-1-D()}function On(e){return e.reduce((t,n)=>Math.max(t,n.sort_weight||0),0)+1+D()}function ec(e,t,n){let r=n.length,o=e<t;if(r<=0||e>=r-1)return On(n);if(e<=0)return $n(n);n=vo([...n]);let i=o?-1:0,a=n[e+i].sort_weight||0,u=(n[e+i+1].sort_weight||0)-a;if(u===0)return o?$n(n):On(n);let c=a+u/2,f=u*.01*(D()-.5);return c+f}function vo(e){return e.sort((t,n)=>(t.sort_weight||0)-(n.sort_weight||0)),e}function rc(e={}){let{getter:t=s=>s.sort}=e;function n(s){return s.sort((u,c)=>(t(u)||0)-(t(c)||0)),s}function r(s){return s.reduce((u,c)=>Math.min(u,t(c)||0),0)-1-D()}function o(s){return s.reduce((u,c)=>Math.max(u,t(c)||0),0)+1+D()}function i(s,u){s==null&&(s=(u??0)-1),u==null&&(u=(s??0)+1);let c=u-s,f=s+c/2,l=c*.01*(D()-.5);return f+l}function a(s,u,c){let f=c.length,l=s<u;if(f<=0||s>=f-1)return o(c);if(s<=0)return r(c);c=n([...c]);let p=l?-1:0,d=t(c[s+p])||0,m=(t(c[s+p+1])||0)-d;if(m===0)return l?r(c):o(c);let b=d+m/2,y=m*.01*(D()-.5);return b+y}return {start:r,end:o,between:i,move:a,items:n}}var Co=/((?:(?:(?:https?|ftp):)?\/\/)(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z0-9\u00A1-\uFFFF][a-z0-9\u00A1-\uFFFF_-]{0,62})?[a-z0-9\u00A1-\uFFFF]\.)+(?:[a-z\u00A1-\uFFFF]{2,}\.?))(?::\d{2,5})?(?:[/?#]\S*)?)/gim;function sc(e){return e.split(Co).map((t,n)=>{let r=Mn(t);return n%2?`<a target="_blank" href="${r}">${Eo(r)}</a>`:r}).join("")}function Eo(e){return e.replace(/^https?:\/\/(www\.)?/,"").replace(/\/$/,"")}function _n(e){let t=[];for(let[n,r]of Object.entries(e))if(r!=null){Array.isArray(r)||(r=[r]);for(let o of r)o!=null&&t.push(`${encodeURIComponent(n)}=${encodeURIComponent(String(o))}`);}return t.join("&")}function ac(e){let t={},n=(e[0]==="?"?e.substr(1):e).split("&");for(let r=0;r<n.length;r++){let o=n[r].split("="),i=decodeURIComponent(o[0]),a=decodeURIComponent(o[1]||"");t[i]!=null?(Array.isArray(t[i])||(t[i]=[t[i]]),t[i].push(a)):t[i]=a;}return t}var Uo=/\\\s|\s+|#[^\n]*\n?/gm,Fo=/\(\?P?<(\w[\w\d_]+)>|\((?!\?(:|\!|=|<=|<\!))/gm,jn=/^((?:\(\?[\w$]+\))?)\(\?<([=!])([\s\S]*?)\)/gm;function Po(e){return typeof e=="string"?e:e.source||""}function cc(e){return e.replace(/[-\[\]{}()*+?.,\\^$|#\s]/g,"\\$&")}var Nn=class{constructor(t,n){this.namedGroups={};this.names=[];let r=n??"",o;if(t instanceof RegExp?(n==null&&(r=t.flags),o=t.source):o=t,r&&r.includes("x")&&(r=r.replace("x",""),o=o.replace(Uo,s=>s[0]==="\\"?s:"")),!(t instanceof RegExp)){let s=0;o=o.replace(Fo,(u,c)=>(s+=1,c?(c!=="index"&&c!=="length"&&!this.namedGroups[c]&&(this.namedGroups[c]=s),"("):u)),this.names=Object.keys(this.namedGroups);}o=Po(o),jn.lastIndex=0;let a=jn.exec(o);a&&(this.lookBehind={rx:new RegExp(`${a[3]}$(?!\\s)`),expect:a?a[2]==="=":!a},o=o.substr(a[0].length)),this.rx=new RegExp(o,r);}get lastIndex(){return this.rx.lastIndex}set lastIndex(t){this.rx.lastIndex=t;}_handleMatch(t){if(this.lookBehind){let n=t.input.slice(0,t.index);if(this.lookBehind.expect!==this.lookBehind.rx.test(n))return null}for(let n of this.names)t[n]=t[this.namedGroups[n]];return t}exec(t){let n;for(;n=this.rx.exec(t);)if(this.rx.lastIndex===n.index&&this.rx.lastIndex++,n=this._handleMatch(n),n!=null)return n}execAll(t){let n=[],r;for(this.rx.lastIndex=0;r=this.exec(t);)n.push(r);return this.rx.lastIndex=0,n}replace(t,n){let r=typeof n=="function"?n:()=>n;return t.replace(this.rx,o=>r(o))}};var Do=",";function pc(e,t={}){let{separator:n=Do}=t,r="";for(let o=0;o<e.length;o++)r+=`${e[o].map(i=>{if(i==null||i==="")return "";if(Sn(i))return i?1:0;let a=String(i);return (_e(i)||H(i))&&(a=k(i)),a.includes('"')||a.includes(`
`)||a.includes(n)?`"${a.replace(/"/g,'""')}"`:a}).join(n)}
`;return r}function So(e,t={}){let n=/("((?:(?:[^"]*?)(?:"")?)*)"|([^,;\t\n]*))([,;\t]|\n|\r\n)/g;t.separator&&(n=new RegExp(n.source.replaceAll(",;\\t",Ne(t.separator)),n.flags));let r=[],o=[],i,a=`${e.replaceAll(`\r
`,`
`).trim()}
`;for(;i=n.exec(a);){let s=i[2]??i[3]??"";s=s.replaceAll('""','"'),o.push(s),i[4]===`
`&&(r.push(o),o=[]);}return r}function dc(e,t={}){let n=So(e,t),r=n[0];return n.slice(1).map(o=>Object.fromEntries(o.map((i,a)=>[r[a],i])))}function Ro(e){let t;if(typeof e=="function"?t=e():S(e)?t=e:typeof e.dispose=="function"?t=e.dispose():S(e.dispose)?t=e.dispose:typeof e.cleanup=="function"?t=e.cleanup():S(e.cleanup)&&(t=e.cleanup),S(t))return t}function Ve(e){let t=e;t!=null&&(Pn(t)?t={name:t}:"debug"in t&&"label"in t&&(t={name:t.label,log:t}));let n=t?.name,r=t?.log??M("zeed:dispose"),o=[];function i(c){if(c!=null&&o.includes(c)){mt(o,l=>l!==c);let f=Ro(c);if(S(f))return f}}function a(c){if(c!=null)return o.unshift(c),()=>i(c)}function s(c=!1){n&&r.debug(`dispose "${n}": ${o.length} entries`);let f=[];for(;o.length>0;){let l=o[0],p=i(l);if(S(p)){if(c)throw new Error(`Async disposable found: ${l} -> ${p}`);f.push(p);}}if(f.length>0)return Promise.all(f)}function u(){s(!0);}return Object.assign(s,{add:a,remove:i,track:a,untrack:i,dispose:s,disposeSync:u,sync:u,exec:s,getSize(){return o.length},isDisposed(){return o.length<=0}})}function bc(e={}){let{mode:t="fifo"}=e,n=[],r=async(i=!1)=>{for(;n.length>0;){let a=n[0];if(mt(n,s=>s!==a),typeof a=="function"){let s=a();if(S(s)){if(i)throw new Error(`Expected sync only function, but found async: ${a}`);await s;}}else if(S(a)){if(i)throw new Error(`Expected sync only function, but found async: ${a}`);await a;}else throw new Error(`Unhandled disposable: ${a}`)}};return Object.assign(r,{add:i=>{t==="lifo"?n.unshift(i):n.push(i);},exec:r,getSize(){return n.length}})}function wc(e,t=0){let n=setTimeout(e,t);return ()=>{n&&(clearTimeout(n),n=void 0);}}function Tc(e,t){let n=setInterval(e,t);return ()=>{n&&(clearInterval(n),n=void 0);}}function Lc(e,t,n,...r){return e==null?()=>{}:(e.on?e.on(t,n,...r):e.addEventListener&&e.addEventListener(t,n,...r),()=>{e.off?e.off(t,n,...r):e.removeEventListener&&e.removeEventListener(t,n,...r);})}function Cc(){let e=!0;return (t,n)=>{let r=!1;if(e){e=!1;try{t(),r=!0;}finally{e=!0;}}else n!==void 0&&n();return r}}function Ec(){let e=!0;return async(t,n)=>{let r=!1;if(e){e=!1;try{let o=t();S(o)&&await o,r=!0;}finally{e=!0;}}else if(n!==void 0){let o=n();S(o)&&await o;}return r}}var I=class{constructor(){this.subscribers={};this.subscribersOnAny=[];this._logEmitter=M("zeed:emitter","warn");this.dispose=Ve();this.call=new Proxy({},{get:(t,n)=>async(...r)=>await this.emit(n,...r)});}async emit(t,...n){let r=!1;try{let o=this.subscribers[t]||[];if(this._logEmitter.debug("emit",this?.constructor?.name,t,...n,o),this.subscribersOnAny.forEach(i=>i(t,...n)),o.length>0){let i=o.map(a=>{try{return me(a(...n))}catch(s){this._logEmitter.warn("emit warning:",s);}return null}).filter(a=>a!=null);r=!0,await Promise.all(i);}}catch(o){this._logEmitter.error("emit exception",o);}return r}onAny(t){this.subscribersOnAny.push(t);}on(t,n){let r=this.subscribers[t]||[];return r.push(n),this.subscribers[t]=r,()=>{this.off(t,n);}}onCall(t){for(let[n,r]of Object.entries(t))this.on(n,r);}once(t,n){let r=async(...o)=>(this.off(t,r),await me(n(...o)));return this.on(t,r),()=>{this.off(t,n);}}off(t,n){return this.subscribers[t]=(this.subscribers[t]||[]).filter(r=>n&&r!==n),this}removeAllListeners(){return this.subscribers={},this}};function Mc(){let e=X().emitter;return e||(e=new I,X().emitter=e),e}function kc(e,t){let n=Math.round(D()*100),r=[],o,i=(s,u)=>{let c={key:s,obj:u};r.push(c),o&&o();};return t?e.on?e.on(t,s=>{i(t,s);}):e.addEventListener?e.addEventListener(t,s=>{i(t,s);}):e.log.error(n,"Cannot listen to key"):e.onAny?e.onAny((s,u)=>{i(s,u);}):e.log.error(n,"cannot listen to all for",e),(s,u=!0)=>new Promise((c,f)=>{s||(s=t,s||r.length&&(s=r[0].key)),o=()=>{for(;r.length>0;){let l=r.shift();if(l.key===s)o=void 0,c(l.obj);else {if(u)continue;f(new Error(`Expected ${s}, but found ${l.key} with value=${l.obj}`));}break}},o();})}function K(){return Date.now()}function At(e){return e>999?`${(e/1e3).toFixed(1)}s`:`${e.toFixed(2)}ms`}function Bc(...e){for(let t of e){if(t instanceof Date)return t;if(typeof t=="string"){let n=null;if(t.includes(":"))try{n=new Date(t);}catch{}if(!(n instanceof Date)){let r=/(\d\d\d\d)-(\d\d)-(\d\d)/.exec(t);r&&(n=new Date(+r[1],+r[2]-1,+r[3],12,0));}if(n instanceof Date)return n}}}function Vn(){return typeof performance<"u"?performance.now():Date.now()}function $c(){let e=Vn();return function(){let t=Vn()-e;return At(t)}}var He=16;function Ct(){return se(He)}function Mo(e=Ct()){return ht(e,22)}function ko(e){return ht(e,22)}function Io(e){return xn(e,He)}function Bo(e=Ct()){return yt(e,26)}function $o(e){return yt(e,26)}function Oo(e){return hn(e,He)}var _o="10000000-1000-4000-8000-100000000000",jo=function(){return typeof crypto<"u"&&crypto.randomUUID!=null?crypto.randomUUID():_o.replace(/[018]/g,e=>(e^se(1)[0]&15>>e/4).toString(16))};function No(e){let t=Wt(e);return `${t.slice(0,8)}-${t.slice(8,12)}-${t.slice(12,16)}-${t.slice(16)}`}function Vo(e){return qt(e.replaceAll("-",""))}var Hn=16e11;function Ho(e){let t=new Uint8Array([0,0,0,0,0,0]),n=t.length-1;for(let r=0;r<t.length;r++){let o=e&255;t[n-r]=o,e=(e-o)/256;}return t}function Gn(){let e=K()-Hn;return new Uint8Array([...Ho(e),...se(10)])}function Hc(){return zo(Gn())}function Gc(e){return Go(Wn(e))}function Go(e){return new Date(Hn+e.slice(0,6).reduce((t,n)=>t*256+n,0))}function zc(){return new Uint32Array(se(4))[0]}var Et={base62:{uuid:Mo,uuidDecode:Io,uuidEncode:ko},base32:{uuid:Bo,uuidDecode:Oo,uuidEncode:$o},uuidv4:{uuid:jo,uuidDecode:Vo,uuidEncode:No}},Ge="base62",zn=!1;function Wc(e,t=!1){Ge=e,zn=t;}function Y(){return Et[Ge].uuid(zn?Gn():Ct())}function Wn(e){return Et[Ge].uuidDecode(e)}function zo(e){return Et[Ge].uuidEncode(e)}function qc(e){try{return Wn(e).length===He}catch{}return !1}var vt={};function _(e="id"){return vt[e]==null&&(vt[e]=0),`${e}-${vt[e]++}`}var Wo=0;function Jc(){return `id-${Wo++}`}var Ut=class extends I{constructor(){super(...arguments);this.id=Y();}close(){this.dispose();}},ze=class extends Ut{constructor(){super(...arguments);this.isConnected=!0;}postMessage(n){this.other?.emit("message",{data:n,origin:"local",lastEventId:Y()});}};function Qc(){let e=new ze,t=new ze;return e.other=t,t.other=e,[e,t]}var qn=class{async encode(t){return t}async decode(t){return t}},ce=class{async encode(t){return Xe(t)}async decode(t){return et(t)}},Jn=class{constructor(t){this.key=t;}async encode(t){let n=Xe(t);return await dn(n,this.key)}async decode(t){let n=await gn(t,this.key);return et(n)}};function Zn(e,t,n={}){return new Proxy(n,{get:(r,o)=>o in r?r[o]:(...i)=>e(o,i,t)})}function ul(e={}){let{name:t=_("hub"),encoder:n=new ce,retryAfter:r=1e3,ignoreUnhandled:o=!0,logLevel:i=!1}=e,a=M(t,i),s={},u,c=[],f,l={},p=()=>{clearTimeout(f);},d=async()=>{if(clearTimeout(f),u){if(u.isConnected)for(;c.length;){let y=c[0];try{u.postMessage(await n.encode(y)),c.shift();}catch(T){a.warn("postMessage",T);break}}c.length>0&&r>0&&(f=setTimeout(d,r));}},g=async y=>{a("enqueue postMessage",y),c.push(y),await d();},m=async y=>{u=y,u.on("connect",d),u.on("message",async T=>{a("onmessage",typeof T);let{name:v,args:U,id:h,result:x,error:L}=await n.decode(T.data);if(v){a(`name ${v} id ${h}`);try{if(s[v]==null)throw new Error(`handler for ${v} was not found`);let C=s[v](...U);S(C)&&(C=await C),a(`result ${C}`),h&&await g({id:h,result:C});}catch(C){let w=C instanceof Error?C:new Error(xt(C));a.warn("execution error",w.name),await g({id:h,error:{message:w.message,stack:w.stack,name:w.name}});}}else if(h)if(a(`response for id=${h}: result=${x}, error=${L}`),l[h]==null)x===void 0?a(`skip response for ${h}`):a.warn(`no response hook for ${h}`);else {let[C,w]=l[h];if(C&&w)if(delete l[h],L){let P=new Error(L.message);P.stack=L.stack,P.name=L.name,a.warn("reject",P.name),w(P);}else a("resolve",x),C(x);}else o||a.warn("Unhandled message",T);}),await d();},b=async(y,T,v={})=>{let{timeout:U=5e3}=v,h=Y();return await g({name:y,args:T,id:h}),Un(new Promise((x,L)=>l[h]=[x,L]),U)};return e.channel&&m(e.channel),{dispose:p,connect:m,listen(y){Object.assign(s,y);},send(){return Zn(b,{},{options(y){return Zn(b,{...y})}})}}}var Ft=class extends I{constructor(n){super();this.publish=this.emit.bind(this);this.subscribe=this.on.bind(this);let{name:r,encoder:o=new ce,channel:i,debug:a=!1}=n;this.channel=i,this.encoder=o,this.debug=a,this.name=r??this.channel.id??_("pubsub"),this.log=M(`${this.shortId}`),this.debug&&(this.channel.on("connect",()=>{this.log("channel connected");}),this.channel.on("disconnect",()=>{this.log("channel disconnected");})),this.channel.on("message",async({data:s})=>{let u=await this.encoder.decode(s);if(this.debug?this.log(`channel message, event=${u?.event}, info=`,u):this.log(`channel message, event=${u?.event}`),u){let{event:c,args:f}=u;await this.emitSuper(c,...f);}});}get shortId(){return this.name.substr(0,6)}async emitSuper(n,...r){return await super.emit(n,...r)}async emit(n,...r){try{if(this.debug?this.log(`emit(${String(n)})`,n):this.log(`emit(${String(n)})`,r.length),!this.channel.isConnected)return this.log.warn("channel not connected"),!1;let o=await this.encoder.encode({event:n,args:r});return this.channel.postMessage(o),!0}catch(o){this.log.warn(`emit(${String(n)})`,o);}return !1}};function gl(e){return new Ft(e)}var Kn=1;var Pt=e=>e,Yn=Pt;function yl(e,t){let{post:n,on:r,eventNames:o=[],serialize:i=Pt,deserialize:a=Yn}=t,s=new Map;return r(async u=>{let c=a(u),[f,l,p,d]=c;if(f===1||f===2){let g,m;if(d!=null)try{let b=e[d];g=await b(...l);}catch(b){m=String(b);}else m="Method implementation missing";f===1&&p&&n(i(m?[4,m,p]:[3,g,p]));}else if(p){let g=s.get(p);g!=null&&(f===4?g.reject(l):g.resolve(l)),s.delete(p);}}),new Proxy({},{get(u,c){let f=(...p)=>{n(i([2,p,null,c]));};if(t.onlyEvents||o.includes(c))return f.asEvent=f,f;let l=(...p)=>new Promise((d,g)=>{let m=Kn++;s.set(m,{resolve:d,reject:g}),n(i([1,p,m,c]));});return l.asEvent=f,l}})}function hl(e){let{post:t,on:n,serialize:r=Pt,deserialize:o=Yn}=e,i=[],a={},s=new Map;n(async c=>{let f=o(c),[l,p,d,g]=f;if(l===1||l===2){let m,b;if(g!=null)try{let y=a[g];m=await y(...p);}catch(y){b=String(y);}else b="Method implementation missing";l===1&&d&&t(r(b?[4,b,d]:[3,m,d]));}else if(d){let m=s.get(d);m!=null&&(l===4?m.reject(p):m.resolve(p)),s.delete(d);}});function u(){return new Proxy({},{get(c,f){let l=(...d)=>{t(r([2,d,null,f]));};if(e.onlyEvents||i.includes(f))return l.asEvent=l,l;let p=(...d)=>new Promise((g,m)=>{let b=Kn++;s.set(b,{resolve:g,reject:m}),t(r([1,d,b,f]));});return p.asEvent=l,p}})}return function(c,f=[]){return Object.assign(a,c??{}),i.push(...f),u()}}var Q=class extends I{constructor(n={}){super();this._isCancelled=!1;this._resetWhenFinished=!0;this._children=[];this._totalUnits=n.totalUnits??0,this._completedUnits=n.completeUnits??0,this._resetWhenFinished=n.resetWhenFinished??!0,this.name=n.name??_("progress"),this.dispose.add(async()=>{for(let r of this._children)await r.dispose();await this.emit("progressDispose",this);});}update(){this.emit("progressChanged",this),this._isCancelled&&this._resetWhenFinished&&this.getTotalUnits()<=this.getCompletedUnits()&&this.reset();}reset(){if(this._isCancelled){this._isCancelled=!1;for(let n of this._children)n.reset();this.update();}}async cancel(){if(!this._isCancelled){this._isCancelled=!0,await this.emit("progressCancelled",this);for(let n of this._children)await n.cancel();this.update();}}addChild(n){n.on("progressDispose",()=>this.removeChild(n)),n.on("progressChanged",()=>this.update()),this._children.includes(n)||this._children.push(n),this.update();}createChildProgress(n){let r=new Q(n);return this.addChild(r),r}removeChild(n){mn(this._children,n),this.update();}getTotalUnits(){if(this.isIndeterminate())return 0;let n=this._totalUnits;for(let r of this._children)n+=r.getTotalUnits();return n}getCompletedUnits(){if(this.isIndeterminate())return 0;let n=this._completedUnits;for(let r of this._children)n+=r.getCompletedUnits();return n}isIndeterminate(){return this._totalUnits<=0&&this._children.length<=0}isCancelled(){return this._isCancelled}isFinished(){return this.dispose.isDisposed()||!this.isIndeterminate()&&this.getTotalUnits()<=this.getCompletedUnits()}getFraction(){if(this.isIndeterminate())return 0;let n=this.getCompletedUnits()/this.getTotalUnits();return isNaN(n)&&(n=0),Math.min(1,Math.max(0,n))}getChildrenCount(){return this._children.length}setTotalUnits(n,r){this._totalUnits=n,r!=null&&(this._completedUnits=r),this.update();}incTotalUnits(n=1){this._totalUnits+=n,this.update();}setCompletetedUnits(n){this._completedUnits=n,this.update();}setCompleted(){this._completedUnits=this._totalUnits,this.update();}incCompletedUnits(n=1){this._completedUnits+=n,this.update();}toString(n=0){let r=`${"  ".repeat(n)}${this.name}: ${this._completedUnits} of ${this._totalUnits} units, ${Math.floor(this.getFraction()*100)} %, cancel=${this._isCancelled}
`;for(let o of this._children)r+=o.toString(n+1);return n===0?r.trim():r}};function Fl(e={}){let{maxParallel:t=3,name:n=_("pool"),idConflictResolution:r="memoize"}=e,o=new I,i=Ve();i.add(T);let a=new Q({name:n});a.on("progressCancelled",T);let s=0,u=0,c=0,f=0,l={};async function p(){if(s>0){let[h,x]=En();return o.once("didFinish",x),h}}async function d(){for(let h of Object.keys(l))l[h].state==="finished"&&(await l[h].progress.dispose(),delete l[h]);}function g(){o.emit("didFinish"),s=0,u=0,d(),a.reset();}function m(){let h=0,x=0;for(let{max:L,resolved:C,state:w}of Object.values(l))h+=L,x+=w==="finished"?L:Math.min(L,C);o.emit("didUpdate",s,u,h,x);}function b(){if(m(),s>0&&s===u&&g(),c>=t)return;let h=Object.values(l).filter(x=>x.state==="waiting");if(h.length>0){let x;for(let L of h)L.group!=null&&Object.values(l).some(C=>C.state==="running"&&C.id!==L.id&&C.group===L.group)||(x==null||L.priority<x.priority)&&(x=L);if(x!=null){let L=x.id,C=x.done;x.state="running",++c,o.emit("didStart",L);let w=P=>{x&&(x.result=P,x.state="finished",x.resolved=x.max,x.progress?.setCompleted()),--c,++u,b();};x.task(x).then(P=>{C(P),o.emit("didResolve",L,P),w(P);}).catch(P=>{C(),o.emit("didReject",L,P),w();});}}}function y(h){let x=l[h];x&&x.state==="waiting"&&(l[h].state="finished",++u,o.emit("didCancel",h),l[h].progress.dispose(),m());}function T(){Object.keys(l).forEach(y);}function v(h){return l[h]!=null}function U(h,x={}){let L,C=new Promise(R=>L=R),w=x.id??Y();if(l[w]!=null){let R=x.idConflictResolution??r;if(R==="replace")y(w);else if(R==="memoize"||R==="prioritize"){let _t=l[w];return R==="prioritize"&&(_t.priority=++f),{id:w,promise:(async()=>{if(_t.state==="finished")return l[w].result})(),dispose:()=>y(w),cancel:()=>y(w)}}else throw new Error(`Pool task with id=${w} already exists!`)}let P=new Q({name:w,totalUnits:x.max??1,completeUnits:x.resolved??0});return a.addChild(P),l[w]={id:w,task:h,priority:++f,group:x.group,state:"waiting",max:x.max??1,resolved:x.resolved??0,done:L,payload:x.payload,progress:P,setMax(R){P.setTotalUnits(R),l[w].max=R,m();},setResolved(R){P.setCompletetedUnits(R),l[w].resolved=R,m();},incResolved(R=1){P.incCompletedUnits(R),l[w].resolved+=R,m();}},++s,b(),{id:w,promise:C,dispose:()=>y(w),cancel:()=>y(w)}}return {events:o,cancel:y,cancelAll:T,hasById:v,progress:a,enqueue:U,dispose:i,waitFinishAll:p}}var Qn=class extends I{constructor(n={}){super();this.queue=[];this.waitToFinish=[];this.countMax=0;this.countResolved=0;this.paused=!1;let{name:r=_("queue"),logLevel:o}=n;this.name=r,this.log=M(`zeed:queue:${r}`,o??ee);}async performNext(){if(this.log("performNext, queue.length =",this.queue.length),this.currentTask!=null){this.log("performNext => skip while another task is running");return}if(this.paused){this.log("performNext => skip while is paused");return}for(;this.currentTask==null&&!this.paused;){let n=this.queue.shift();if(this.log(`performNext => ${n?.name}`),n==null)break;this.countResolved===0&&this.emit("didStart",this.countMax);let{name:r,task:o,resolve:i}=n;this.currentTask=o();let a;try{this.log.info(`start task ${r}`),a=await this.currentTask,this.log(`finished task ${r} with result =`,a);}catch(s){this.log.warn("Error performing task",s);}i(a),this.currentTask=void 0,this.countResolved+=1,this.emit("didUpdate",this.countMax,this.countResolved);}for(this.queue.length===0&&(this.emit("didFinish"),this.countMax=0,this.countResolved=0);this.waitToFinish.length>0;)this.waitToFinish.shift()();}async enqueue(n,r={}){let{immediate:o=!1,name:i=_(this.name)}=r;return o?(this.log.info(`immediate execution ${i}`),await n()):(this.log(`enqueue ${i}`),new Promise(a=>{this.queue.push({name:i,task:n,resolve:a}),this.countMax+=1,this.emit("didUpdate",this.countMax,this.countResolved),this.performNext();}))}async enqueueReentrant(n,r={}){return this.enqueue(n,{immediate:this.currentTask!=null,name:r.name})}async cancelAll(n=!0){this.log("cancelAll"),this.emit("didCancel");let r=this.queue.map(o=>o.resolve);this.queue=[],r.forEach(o=>o(void 0)),await this.wait();}async pause(){this.log("pause"),this.paused=!0,await this.wait();}resume(){this.log("resume"),this.paused=!1,this.performNext();}async wait(){if(this.log("wait"),!(this.currentTask==null&&(this.queue.length===0||this.paused)))return new Promise(n=>{this.waitToFinish.push(n);})}get isPaused(){return this.paused}get hasTasks(){return this.queue.length!==0}};function Bl(e,t={}){let{delay:n=100,trailing:r=!0,leading:o=!0}=t,i=0,a=0,s=0,u;function c(){return i?(clearTimeout(i),i=void 0,!0):!1}function f(...l){let p=Date.now(),d=p-a,g=()=>{s=0,a=Date.now(),e.apply(this,l);};if(u=g,d>n||!i){o&&(d>n?g():++s);let m=d>n?n:n-d;c(),a=p,i=setTimeout(()=>{i=0,r&&(!o||s>0)&&u?.();},m);}else ++s;}return f.cancel=c,f.stop=()=>{c()&&u&&u();},f.immediate=async function(...p){c(),a=Date.now(),e.apply(this,p);},f.dispose=()=>f.stop(),f}function $l(e,t={}){let{delay:n=100}=t,r=0,o=!1,i;function a(){r&&(clearTimeout(r),r=0);}async function s(){try{if(a(),i!=null){let f=[...i];i=void 0,o=!0,await me(e(...f)),o=!1,i!=null&&(a(),r=setTimeout(s,n));}}catch{}}function u(...f){i=[...f],a(),o===!1&&(r=setTimeout(s,n));}async function c(...f){a(),i=[...f],await s();}return u.cancel=a,u.dispose=a,u.immediate=c,u}function _l(e=globalThis?.location?.hostname??""){return ["::ffff:127.0.0.1","localhost","127.0.0.1","","::1","::"].includes(e)||e.startsWith("192.168.")||e.startsWith("10.0.")||e.endsWith(".local")}var Xn=["#0000CC","#0000FF","#0033CC","#0033FF","#0066CC","#0066FF","#0099CC","#0099FF","#00CC00","#00CC33","#00CC66","#00CC99","#00CCCC","#00CCFF","#3300CC","#3300FF","#3333CC","#3333FF","#3366CC","#3366FF","#3399CC","#3399FF","#33CC00","#33CC33","#33CC66","#33CC99","#33CCCC","#33CCFF","#6600CC","#6600FF","#6633CC","#6633FF","#66CC00","#66CC33","#9900CC","#9900FF","#9933CC","#9933FF","#99CC00","#99CC33","#CC0000","#CC0033","#CC0066","#CC0099","#CC00CC","#CC00FF","#CC3300","#CC3333","#CC3366","#CC3399","#CC33CC","#CC33FF","#CC6600","#CC6633","#CC9900","#CC9933","#CCCC00","#CCCC33","#FF0000","#FF0033","#FF0066","#FF0099","#FF00CC","#FF00FF","#FF3300","#FF3333","#FF3366","#FF3399","#FF33CC","#FF33FF","#FF6600","#FF6633","#FF9900","#FF9933","#FFCC00","#FFCC33"];function Nl(e){let t=0;for(let n=0;n<e.length;n++)t=(t<<5)-t+e.charCodeAt(n),t|=0;return Xn[Math.abs(t)%Xn.length]}function zl(e){let{level:t=void 0,filter:n=void 0,messages:r=[]}=e,o=j(n),i=G(t);return a=>{i(a.level)&&o(a.name)&&(a.timestamp=K(),r.push(a));}}var Dt={cache:"no-cache",redirect:"follow",headers:{}};function qo(e){let t=/:\/\/([^@]*)@/gi.exec(e);if(t&&t[1]){let[n,r]=t[1].split(":",2);return {url:e.replace(`${t[1]}@`,""),username:n,password:r}}}async function er(e,t={},n=fetch){try{H(t)&&(t=je({},...ae(t)));let r=qo(String(e));r&&(e=r.url,t=je({},t,Jo(r.username,r.password))),t.headers!=null&&!(t.headers instanceof Headers)&&(t.headers=new Headers(t.headers));let o=await n(String(e),t);if(o.status<400)return o;let i=M("zeed:network");try{i.warn(`Fetch of ${String(e)} returned status=${o.status}. Options:`,t),i.warn(`Response: ${await o.text()}`);}catch(a){i.error("Exception:",a);}}catch(r){M("zeed:network").error("fetchBasic",r);}}async function Kl(e,t={},n=fetch){try{let r=await er(e,[{method:"GET",headers:{Accept:"application/json"}},t],n);if(r)return await r.json()}catch(r){M("zeed:network").error("fetchJSON error:",r);}}async function Yl(e,t={},n=fetch){try{let r=await er(e,[Dt,{method:"GET"},t],n);if(r)return await r.text()}catch(r){M("zeed:network").error("fetchHTML error:",r);}}function Ql(e,t="POST"){return {method:t,...Dt,headers:{"Content-Type":"application/x-www-form-urlencoded; charset=utf-8"},body:_n(e)}}function Xl(e,t="POST"){return {method:t,...Dt,headers:{"Content-Type":"application/json; charset=utf-8"},body:k(e)}}function Jo(e,t){return {headers:{Authorization:`Basic ${le(`${e}:${t}`)}`}}}function tr(){if(typeof window<"u")return window}function Zo(){if(typeof navigator<"u")return navigator}function tf(){return tr()??typeof WorkerGlobalScope<"u"?self:typeof global<"u"?global:Function("return this;")()}function nf(e={ios:!1,macos:!1,windows:!1,beaker:!1,electron:!1,wkwebview:!1,pwa:!1,pwaInstalled:!1,browser:!1,node:!1,worker:!1,test:!1,jest:!1,macosNative:!1,iosNative:!1,appleNative:!1,touch:!1}){let t=Zo(),n=tr();return e.ios=t?.platform?.match(/(iPhone|iPod|iPad)/i)!=null,e.macos=!!t?.platform?.startsWith("Mac"),e.windows=!!t?.platform?.startsWith("Win"),e.beaker=n?.beaker!=null,e.electron=(t?.userAgent?.toLowerCase()?.indexOf(" electron/")||-1)>-1&&!e.beaker,e.wkwebview=n?.webkit?.messageHandlers!=null,e.pwa=t?.serviceWorker!=null,e.pwaInstalled=t?.standalone||n?.matchMedia?.("(display-mode: standalone)")?.matches,e.node=typeof process<"u"&&process?.release?.name==="node",e.browser=!e.electron&&!e.wkwebview&&!e.node,e.worker=typeof WorkerGlobalScope<"u"&&self instanceof WorkerGlobalScope,e.jest=typeof jest<"u"||typeof vitest<"u",e.test=e.jest,e.macosNative=e.wkwebview&&e.macos,e.iosNative=e.wkwebview&&e.ios,e.appleNative=e.wkwebview,e.touch=n&&"ontouchstart"in n||(t?.maxTouchPoints||0)>1||t?.msPointerEnabled&&n?.MSGesture||n?.DocumentTouch&&document instanceof DocumentTouch,e}function Ko(){return typeof window<"u"&&globalThis===window}function rf(e){Ko()?window.addEventListener("beforeunload",e):typeof process<"u"&&process.on("exit",()=>e);}var nr=class{constructor(t={}){this.store={};}setItem(t,n){this.store[t]=ue(n);}getItem(t){return ue(this.store[t])}removeItem(t){delete this.store[t];}clear(){this.store={};}allKeys(){return Object.keys(this.store)}};function uf(){}function ff(e={}){let{args:t=process.argv.slice(1),alias:n={},normalize:r=bn,booleanArgs:o=[],listArgs:i=[],numberArgs:a=[]}=e,s=Object.entries(n).reduce((p,d)=>{let[g,m]=d;typeof m=="string"&&(m=[m]);for(let b of m)p[r(b)]=r(g);return p},{}),u={_:[]};function c(p,d){u[p]==null||typeof u[p]=="boolean"?u[p]=d:Array.isArray(u[p])?u[p].push(d):u[p]=[u[p],d];}let f=[...t],l;for(;l=f.shift();){let p;if(/^--?/.test(l)){let d=l.replace(/^--?/,"");if(l.includes("=")){let[g,m]=d.split("=",2);d=g.trim(),p=m.trim();}d=r(d),d=s[d]??d,o.includes(d)?c(d,!0):(p=p??f.shift()??"",a.includes(d)&&(p=Number(p??0)),i.includes(d)?Array.isArray(u[d])?u[d].push(p):u[d]=[p]:c(d,p));}else u._.push(l);}return u}function df(e){return new Promise((t,n)=>{import('child_process').then(({spawn:r})=>{let o=r("pbcopy");o.on("error",i=>n(i)),o.on("close",()=>t(e)),o.stdin.write(e),o.stdin.end();}).catch(()=>{});})}function yf(){try{typeof globalThis<"u"&&typeof globalThis.crypto>"u"&&St__default.default&&St__default.default.webcrypto&&(globalThis.crypto=St__default.default.webcrypto);}catch(e){console.warn("Failed to polyfill webcrypto",e);}}async function hf(){if(globalThis.crypto==null)try{if(typeof globalThis<"u"&&typeof globalThis.crypto>"u"){let e=await import('crypto');globalThis.crypto=e.webcrypto;}}catch(e){console.warn("Failed to polyfill webcrypto",e);}return globalThis.crypto}var Qo=`
`,Xo=/^\s*([\w_.-]+)\s*=\s*(.*)?\s*$/,ei=/\\n/g,ti=/\n|\r|\r\n/;function rr(e,t={}){let n={};return String(e).split(ti).forEach((r,o)=>{let i=r.match(Xo);if(i!=null){let a=i[1],s=i[2]||"",u=s.length-1,c=s[0]==='"'&&s[u]==='"';s[0]==="'"&&s[u]==="'"||c?(s=s.substring(1,u),c&&(s=s.replace(ei,Qo))):s=s.trim(),n[a]=s;}}),n}function ni(e,t="."){return path.resolve(process.cwd(),e??t)}function ri(e,t=""){return e==null&&(e=t),ni(String(e).trim(),t)}var Rt=ri;function Tf(e,t=process.env){if(t[e]!=null)return t[e];e=e.toLowerCase();for(let[n,r]of Object.entries(t))if(n.toLowerCase()===e)return r}function Lf(e={}){let t=e?.path??Rt(e?.filename??".env"),n=e?.encoding??"utf8",r=e?.debug||!1;try{let o=We__default.default.existsSync(t)?rr(We__default.default.readFileSync(t,{encoding:n}),{debug:r}):{},i=We__default.default.existsSync(`${t}.local`)?rr(We__default.default.readFileSync(`${t}.local`,{encoding:n}),{debug:r}):{},a=Object.assign({},o,i),s=e?.env??process.env;return Object.entries(a).forEach(([u,c])=>{typeof e?.prefix=="string"&&(u=e?.prefix+u),Object.prototype.hasOwnProperty.call(s,u)||c!=null&&(s[u]=c);}),{parsed:a}}catch(o){return {error:o}}}function Ef(e){let t=path.normalize(e),n=process.env.HOME;return n&&t.startsWith(n)?`~${t.slice(n.length)}`:t}async function kt(e){try{await promises.stat(e);}catch{return !1}return !0}function qe(e){return e.startsWith(".")||e.includes("/.")}async function Uf(...e){let t=path.join(...e);return await kt(t)||await promises.mkdir(t,{recursive:!0}),t}async function Ff(...e){let t=path.join(...e);return await kt(t)&&await promises.rm(t,{recursive:!0}),t}async function Pf(...e){let t=path.join(...e);if(await kt(t))return await promises.readFile(t,"utf-8")}async function Df(e,t){await promises.writeFile(e,t,"utf-8");}function Je(e,t){if(typeof e!="string")throw new TypeError("Expected a string");let n=String(e),r="",o=t?!!t.extended:!1,i=t?!!t.globstar:!1,a=!1,s=t&&typeof t.flags=="string"?t.flags:"",u;for(let c=0,f=n.length;c<f;c++)switch(u=n[c],u){case"/":case"$":case"^":case"+":case".":case"(":case")":case"=":case"!":case"|":r+=`\\${u}`;break;case"?":o&&(r+=".");break;case"[":case"]":o&&(r+=u);break;case"{":o&&(a=!0,r+="(");break;case"}":o&&(a=!1,r+=")");break;case",":a?r+="|":r+=`\\${u}`;break;case"*":{let l=n[c-1],p=1;for(;n[c+1]==="*";)p++,c++;let d=n[c+1];i?p>1&&(l==="/"||l===void 0)&&(d==="/"||d===void 0)?(r+="((?:[^/]*(?:/|$))*)",c++):r+="([^/]*)":r+=".*";}break;default:r+=u;}return (!s||!~s.indexOf("g"))&&(r=`^${r}$`),new RegExp(r,s)}function ir(e){try{return We.statSync(e)}catch{}}function $f(e){let{mtimeMs:t,size:n}=ir(e)??{};return `${e}|${t}|${n}`}function sr(e,t="",n=!0){let r=[],o=We.readdirSync(path.resolve(e,t));if(o!=null&&o.length>0)for(let i of o){if(i=path.join(t,i),n&&qe(i))continue;let a=path.join(e,i),s=ir(a);s&&s.isDirectory()?r=r.concat(sr(e,i)||[]):r.push(i);}return r}function Of(e={}){let{pattern:t,filter:n,basePath:r=process.cwd(),ignoreHidden:o=!1}=e,i=sr(r,"",o);if(i=i.filter(a=>!(o&&(a.startsWith(".")||a.includes("/.")))),t&&(typeof t=="string"&&(t=Je(t)),t instanceof RegExp)){let a=t;a.lastIndex=0,i=i.filter(s=>a.test(s));}return n&&(i=i.filter(n)),i}async function ur(e){try{return await promises.stat(e)}catch{}}async function Gf(e){let{mtimeMs:t,size:n}=await ur(e)??{};return `${e}|${t}|${n}`}async function cr(e,t="",n=!0){let r=[],o=await promises.readdir(path.resolve(e,t));if(o!=null&&o.length>0)for(let i of o){if(i=path.join(t,i),n&&qe(i))continue;let a=path.join(e,i),s=await ur(a);s&&s.isDirectory()?r=r.concat(await cr(e,i)||[]):r.push(i);}return r}async function zf(e={}){let{pattern:t,filter:n,basePath:r=process.cwd(),ignoreHidden:o=!1}=e,i=await cr(r,"",o);if(i=i.filter(a=>!(o&&(a.startsWith(".")||a.includes("/.")))),t&&(typeof t=="string"&&(t=Je(t)),t instanceof RegExp)){let a=t;a.lastIndex=0,i=i.filter(s=>a.test(s));}return n&&(i=i.filter(n)),i}var pr=class{constructor(t={}){this.store={};this.fileKeys=void 0;this.pretty=!1;this.dirname=path.resolve(process.cwd(),t.path??".fileStorage"),this.pretty=!!t.pretty,this.extension=t.extension??".json",t.extension&&!this.extension.startsWith(".")&&(this.extension=`.${this.extension}`),this.extensionLength=this.extension.length,this.objectToString=t.objectToString??(n=>this.pretty?k(n,null,2):k(n)),this.objectFromString=t.objectFromString??(n=>{try{return JSON.parse(n)}catch{}}),this.keyToFilename=t.keyToFilename??In;}setItem(t,n){this.store[t]=ue(n);try{let r=this.objectToString(n),o=this.getPath(t);We.mkdirSync(path.dirname(o),{recursive:!0}),We.writeFileSync(o,r,"utf8");}catch{}}getPath(t){return path.resolve(this.dirname,this.keyToFilename(t)+this.extension)}getBuffer(t){let n=this.getPath(t);return buffer.Buffer.from(We.readFileSync(n))}getItem(t){let n=this.store[t];if(n!==null){if(n!=null)return ue(n);try{let r=this.getPath(t),o=We.readFileSync(r,"utf8");if(o!=null){let i=this.objectFromString(o);return this.store[t]=i,i}}catch{this.store[t]=null;}}}removeItem(t){if(delete this.store[t],this.fileKeys!=null){let n=this.fileKeys.indexOf(t);n!==-1&&this.fileKeys.splice(n,1);}try{let n=this.getPath(t);We.unlinkSync(n);}catch{}}clear(){this.fileKeys=[],this.store={},We.rmSync(this.dirname,{recursive:!0,force:!0});}allKeys(){if(this.fileKeys==null)try{this.fileKeys=We.readdirSync(this.dirname,{withFileTypes:!0}).filter(n=>!n.isDirectory()&&n.name.endsWith(this.extension)).map(n=>n.name.slice(0,-this.extensionLength))||[];}catch{}let t=[...this.fileKeys||[]];for(let n of Object.keys(this.store))t.includes(n)||t.push(n);return t.sort(),t}};var dr={};function gr(e,t={}){let{level:n=void 0,filter:r=void 0,time:o=!0,pretty:i=!1}=t;e=path.resolve(process.cwd(),e),We.mkdirSync(path.dirname(e),{recursive:!0});let a=We.createWriteStream(e,{flags:"a"}),s=j(r),u=G(n);return c=>{if(!u(c.level)||!s(c.name))return;let f=o?`${new Date().toISOString()} `:"",l=c.name||"",p=dr[l||""];p==null&&(dr[l]=p);let d=[`[${l||"*"}]`,Be(c.messages,{pretty:i})];function g(...m){a.write(`${m.join("	")}
`);}switch(c.level){case O:g(`${f}I|*  `,...d);break;case B:g(`${f}W|** `,...d);break;case $:g(`${f}E|***`,...d);break;default:g(`${f}D|   `,...d);break}}}function Ui(e){return typeof e!="string"?[]:e?.split(`
`).map(t=>{let n=t.match(/^\s+at.*(\((.*)\)|file:\/\/(.*)$)|\s*at\s(\/.*)$/);if(n){let r=n[3]||n[2]||n[4];return r.endsWith(")")&&(r=r.slice(0,-1)),r}})?.filter(Rn)??[]}function yr(e){if(e.includes("/node_modules/"))return "";let t="file://";if(e.startsWith(t))return e.substr(t.length);let n=path.resolve(process.cwd());if(n&&e.startsWith(n))return e.substr(n.length+1);let r=process.env?.HOME?path.resolve(process.env?.HOME):"";return r&&e.startsWith(r)&&(e=`~/${e.substr(r.length+1)}`),e}function Fi(e){let t=e.match(/^\s*at.*(\((.*)\)|file:\/\/(.*)$)|\s*at\s(\/.*)$/);if(t){let n=t[3]||t[2]||t[4];return n.endsWith(")")&&(n=n.slice(0,-1)),n}return ""}function It(e=2,t=!0){let n=new Error("stack").stack||"",r=Ui(n)?.[e];return r&&t&&(r=yr(r)),r||""}function hr(){return new Error("stack").stack||""}function xr(e,t=!0){let n="",r=new Error("stack").stack||"";if(typeof r=="string"){let o=r.split(`
`).map(a=>a.trim()),i=o.findIndex(a=>e.some(s=>a.startsWith(s)));n=o[i+1],n&&(n=Fi(n)),n&&t&&(n=yr(n));}return n}function Di(){try{return Z(process.env.ZEED_COLOR,Pi__default.default.isatty(process.stdout.fd))}catch{}return !1}var Bt,br=[6,2,3,4,5,1];function Si(e){let t=0;for(let n=0;n<e.length;n++)t=(t<<5)-t+e.charCodeAt(n),t|=0;return br[Math.abs(t)%br.length]}var wr={},$t;function Ze(...e){process.stdout.write(`${Be(e)}
`);}var xe={BOLD:"\x1B[1m",UNBOLD:"\x1B[2m",RED:"\x1B[31m",GREEN:"\x1B[32m",BLUE:"\x1B[34m",PURPLE:"\x1B[35m",GRAY:"\x1B[37m",ORANGE:"\x1B[38;5;208m",UNCOLOR:"\x1B[0m"};var Lr="\x1B[0m";function he(e,t){return `${t===8?xe.ORANGE:`\x1B[3${t<8?t:`8;5;${t}`}m`}${e}${Lr}`}function Tr(e,t,n=!0){return e.map(r=>{if(typeof r!="string")return r;let o=t,i=Lr;return n&&(o=`${xe.BOLD}${o}`,i=`${i}${xe.BOLD}`),`${o}${r}${i}`})}function Ri(){try{return Z(process.env.ZEED_STACK,!1)}catch{}return !1}var Ot,Mi="loggerStackTraceDebug-7d38e5a9214b58d29734374cdb9521fd964d7485";function Ar(e={}){Bt==null&&(Bt=Di()),Ot==null&&(Ot=Ri()),$t==null&&($t=K());let{level:t=void 0,filter:n=void 0,colors:r=Bt,levelHelper:o=!0,nameBrackets:i=!0,padding:a=0,fill:s=0,stack:u=Ot,time:c=!0}=e,f=j(n),l=G(t);return p=>{if(!l(p.level)||!f(p.name))return;let d=K(),g=p.name||"",m=wr[g||""];m==null&&(m={color:Si(g)},wr[g]=m);let b=At(d-$t),y,T=i?`[${g}]`:g;if(a>0&&(T=T.padStart(a," ")),s>0&&(T=T.padEnd(s," ")),r){let h=m.color;y=[`${he(T,h)} | `],p.level===B?y.push(...Tr(p.messages,xe.ORANGE)):p.level===$?y.push(...Tr(p.messages,xe.RED)):y.push(...p.messages),c&&y.push(he(`+${b}`,h));}else y=[T,...p.messages],c&&y.push(`+${b}`);if(p.messages?.[0]===Mi&&console.log(hr()),u){let h="";typeof u=="boolean"?(h=xr(["at Function.","at null.log (","at log ("],!0),h||(h=It(0,!0))):h=It(typeof u=="number"?u:3,!0),h&&y.push(he(`(${h})`,7));}let v="|",U=".";switch(p.level){case O:o&&(y[0]=`I${v}${U}   ${y[0]}`),Ze(...y);break;case B:o&&(y[0]=(r?he(`W${v}${U}${U}  `,8):`W${v}${U}${U}  `)+y[0]),Ze(...y);break;case $:o&&(y[0]=(r?he(`E${v}${U}${U}${U} `,1):`E${v}${U}${U}${U} `)+y[0]),Ze(...y);break;default:o&&(y[0]=`D${v}    ${y[0]}`),Ze(...y);break}}}function ki(e,t){return Qe(n=>{let r=[Ar({padding:32,nameBrackets:!1})],o=process.env.ZEED_LOG??process.env.LOG,i=Z(process.env.ZEED_TIME,!0),a=Z(process.env.ZEED_PRETTY,!1);o&&r.unshift(gr(Rt(o),{time:i,pretty:a})),n.setHandlers(r);})(e,t)}

exports.BinaryEncoder = cn;
exports.CRYPTO_DEFAULT_ALG = ft;
exports.CRYPTO_DEFAULT_DERIVE_ALG = ln;
exports.CRYPTO_DEFAULT_DERIVE_ITERATIONS = Jr;
exports.CRYPTO_DEFAULT_HASH_ALG = fn;
exports.Channel = Ut;
exports.CryptoEncoder = Jn;
exports.DAY_MS = Tn;
exports.Day = A;
exports.DefaultLogger = M;
exports.Emitter = I;
exports.FileStorage = pr;
exports.JsonEncoder = ce;
exports.LocalChannel = ze;
exports.LogLevelAlias = jt;
exports.LogLevelAll = z;
exports.LogLevelDebug = q;
exports.LogLevelError = $;
exports.LogLevelFatal = we;
exports.LogLevelInfo = O;
exports.LogLevelOff = ee;
exports.LogLevelWarn = B;
exports.Logger = ki;
exports.LoggerConsoleHandler = be;
exports.LoggerContext = Nt;
exports.LoggerFileHandler = gr;
exports.LoggerMemoryHandler = zl;
exports.LoggerNodeHandler = Ar;
exports.MemStorage = nr;
exports.NoopEncoder = qn;
exports.Progress = Q;
exports.PubSub = Ft;
exports.SerialQueue = Qn;
exports.Uint8ArrayToDataUri = Da;
exports.Uint8ArrayToHexDump = Zt;
exports.Uint8ArrayToJson = et;
exports.Uint8ArrayToString = zt;
exports.XRX = Nn;
exports._decodeUtf8Polyfill = Mr;
exports._encodeUtf8Polyfill = Rr;
exports._useBase = oo;
exports.arrayAvg = ta;
exports.arrayBatches = na;
exports.arrayEmptyInPlace = qs;
exports.arrayFilterInPlace = mt;
exports.arrayFlatten = ae;
exports.arrayIntersection = eo;
exports.arrayIsEqual = no;
exports.arrayMax = Qs;
exports.arrayMin = Xs;
exports.arrayMinus = Qr;
exports.arrayRandomElement = Ys;
exports.arrayRemoveElement = mn;
exports.arraySetElement = zs;
exports.arrayShuffle = Zs;
exports.arrayShuffleForce = Ks;
exports.arrayShuffleInPlace = yn;
exports.arraySorted = to;
exports.arraySortedNumbers = Js;
exports.arraySum = ea;
exports.arraySymmetricDifference = Gs;
exports.arrayToggleInPlace = Ws;
exports.arrayUnion = Xr;
exports.arrayUnique = gt;
exports.assert = Pr;
exports.assertCondition = Ht;
exports.avg = ks;
exports.between = Ms;
exports.bitfield = As;
exports.blobToArrayBuffer = qr;
exports.blobToDataUri = Pa;
exports.blobToUint8Array = vs;
exports.browserSelectColorByName = Nl;
exports.cloneJsonObject = lu;
exports.cloneObject = ue;
exports.cmp = dt;
exports.colorString = he;
exports.colorStringList = Tr;
exports.composeOrderby = _s;
exports.createArray = ra;
exports.createBinaryStreamDecoder = Ls;
exports.createBinaryStreamEncoder = Ts;
exports.createLocalChannelPair = Qc;
exports.createPromise = En;
exports.createPromiseProxy = Zn;
exports.csvParse = So;
exports.csvParseToObjects = dc;
exports.csvStringify = pc;
exports.dataUriToBlob = Fa;
exports.dataUriToMimeType = Ua;
exports.dataUriToUint8Array = Ea;
exports.dateStringToDays = Qa;
exports.day = Ya;
exports.dayDay = co;
exports.dayDiff = Oa;
exports.dayFromAny = Ma;
exports.dayFromDate = Oe;
exports.dayFromDateGMT = Ia;
exports.dayFromParts = Tt;
exports.dayFromString = Cn;
exports.dayFromTimestamp = lo;
exports.dayFromToday = vn;
exports.dayIterator = ja;
exports.dayMonth = Ln;
exports.dayMonthStart = Ba;
exports.dayOffset = $e;
exports.dayRange = _a;
exports.dayToDate = An;
exports.dayToDateGMT = ka;
exports.dayToParts = Ra;
exports.dayToString = fo;
exports.dayToTimestamp = bt;
exports.dayYear = wt;
exports.dayYearStart = $a;
exports.debounce = $l;
exports.decimal = po;
exports.decimalCentsPart = nu;
exports.decimalFromCents = eu;
exports.decimalToCents = tu;
exports.decodeBase16 = aa;
exports.decodeBase32 = hn;
exports.decodeBase58 = ca;
exports.decodeBase62 = xn;
exports.decodeJson = ws;
exports.decrypt = gn;
exports.deepEqual = mo;
exports.deepMerge = je;
exports.deepStripUndefinedInPlace = yo;
exports.deriveKeyPbkdf2 = Fs;
exports.detect = nf;
exports.diffObjects = ho;
exports.digest = Us;
exports.duration = $c;
exports.empty = cu;
exports.encodeBase16 = sa;
exports.encodeBase32 = yt;
exports.encodeBase58 = ua;
exports.encodeBase62 = ht;
exports.encodeJson = bs;
exports.encodeQuery = _n;
exports.encrypt = dn;
exports.endSortWeight = On;
exports.ensureFolder = Uf;
exports.ensureKey = iu;
exports.ensureKeyAsync = su;
exports.equalBinary = Jt;
exports.escapeHTML = Mn;
exports.escapeRegExp = Ne;
exports.estimateSizeForBase = la;
exports.exists = kt;
exports.fatal = Fr;
exports.fetchBasic = er;
exports.fetchJson = Kl;
exports.fetchOptionsBasicAuth = Jo;
exports.fetchOptionsFormURLEncoded = Ql;
exports.fetchOptionsJson = Xl;
exports.fetchText = Yl;
exports.files = Of;
exports.filesAsync = zf;
exports.first = au;
exports.fixBrokenUth8String = Aa;
exports.forEachDay = Za;
exports.forTimes = du;
exports.formatMessages = uo;
exports.formatMilliseconds = At;
exports.fromBase64 = Ae;
exports.fromBase64String = ns;
exports.fromCamelCase = da;
exports.fromHex = qt;
exports.getEnvVariableRelaxed = Tf;
exports.getFingerprint = $f;
exports.getFingerprintAsync = Gf;
exports.getGlobal = tf;
exports.getGlobalContext = X;
exports.getGlobalEmitter = Mc;
exports.getGlobalLogger = Qe;
exports.getGlobalLoggerIfExists = Vt;
exports.getNamespaceFilterString = Cr;
exports.getNavigator = Zo;
exports.getPerformanceTimestamp = Vn;
exports.getSecureRandom = Zr;
exports.getSecureRandomIfPossible = D;
exports.getSourceLocation = It;
exports.getSourceLocationByPrecedingPattern = xr;
exports.getStack = hr;
exports.getStackLlocationList = Ui;
exports.getStat = ir;
exports.getStatAsync = ur;
exports.getTimestamp = K;
exports.getWebCrypto = hf;
exports.getWindow = tr;
exports.globToRegExp = Je;
exports.immediate = Ha;
exports.isArray = H;
exports.isBoolean = Sn;
exports.isBrowser = Ko;
exports.isEmpty = go;
exports.isEven = Bn;
exports.isHalf = ye;
exports.isHiddenPath = qe;
exports.isInteger = hu;
exports.isLocalHost = _l;
exports.isNotEmpty = Lu;
exports.isNotNull = Rn;
exports.isNull = wu;
exports.isNullOrUndefined = bu;
exports.isNumber = Dn;
exports.isObject = N;
exports.isPrime = Bs;
exports.isPrimeRX = Is;
exports.isPrimitive = Lt;
exports.isPromise = S;
exports.isRecord = _e;
exports.isRecordPlain = yu;
exports.isSafeInteger = xu;
exports.isString = Pn;
exports.isTimeout = za;
exports.isTruthy = vu;
exports.isUint8Array = Tu;
exports.isValue = Au;
exports.joinToUint8Array = es;
exports.jsonStringify = Yi;
exports.jsonStringifySafe = k;
exports.jsonStringifySorted = Ki;
exports.jsonToUint8Array = Xe;
exports.last = uu;
exports.lazyListener = kc;
exports.linkifyPlainText = sc;
exports.listDistinctUnion = Mu;
exports.listGroupBy = Ru;
exports.listOfKey = ku;
exports.listQuery = Su;
exports.loggerStackTraceDebug = Mi;
exports.memoize = fu;
exports.memoizeAsync = pu;
exports.moveSortWeight = ec;
exports.noop = uf;
exports.objectIsEmpty = _u;
exports.objectMap = $u;
exports.objectMergeDisposable = Ou;
exports.parseArgs = ff;
exports.parseBasicAuth = qo;
exports.parseDate = Bc;
exports.parseLogLevel = Ke;
exports.parseOrderby = Yr;
exports.parseQuery = ac;
exports.pbcopy = df;
exports.promisify = me;
exports.qid = Jc;
exports.randomBoolean = Ds;
exports.randomFloat = Rs;
exports.randomInt = Ss;
exports.randomUint8Array = se;
exports.readText = Pf;
exports.regExpEscape = cc;
exports.regExpString = Po;
exports.removeFolder = Ff;
exports.renderMessages = Be;
exports.roundDown = zu;
exports.roundHalfAwayFromZero = Ju;
exports.roundHalfDown = Zu;
exports.roundHalfEven = Ku;
exports.roundHalfOdd = qu;
exports.roundHalfTowardsZero = Yu;
exports.roundHalfUp = Wu;
exports.roundUp = Gu;
exports.seededRandom = $s;
exports.setUuidDefaultEncoding = Wc;
exports.setupEnv = Lf;
exports.setupWebCrypto = yf;
exports.size = Fn;
exports.sleep = Va;
exports.sortedItems = vo;
exports.sortedOrderby = js;
exports.startSortWeight = $n;
exports.stringToBoolean = ya;
exports.stringToFloat = xa;
exports.stringToInteger = ha;
exports.stringToPath = ni;
exports.stringToUInt8Array = Gt;
exports.suid = Hc;
exports.suidBytes = Gn;
exports.suidBytesDate = Go;
exports.suidDate = Gc;
exports.sum = Kr;
exports.throttle = Bl;
exports.timeout = Ga;
exports.toBase64 = le;
exports.toBase64Url = ts;
exports.toBool = La;
exports.toCamelCase = bn;
exports.toCapitalize = io;
exports.toCapitalizeWords = pa;
exports.toFloat = ba;
exports.toHex = Wt;
exports.toHumanReadableFilePath = Ef;
exports.toHumanReadableUrl = Eo;
exports.toInt = wa;
exports.toPath = Rt;
exports.toString = Ta;
exports.toUint8Array = E;
exports.toValidFilename = In;
exports.today = Ka;
exports.tryTimeout = Un;
exports.uname = _;
exports.unescapeHTML = Pu;
exports.useAsyncMutex = Ec;
exports.useBase = W;
exports.useDefer = bc;
exports.useDispose = Ve;
exports.useEventListener = Lc;
exports.useExitHandler = rf;
exports.useInterval = Tc;
exports.useLevelFilter = G;
exports.useMessageHub = ul;
exports.useMutex = Cc;
exports.useNamespaceFilter = j;
exports.usePool = Fl;
exports.usePubSub = gl;
exports.useRPC = yl;
exports.useRPCHub = hl;
exports.useSorted = rc;
exports.useTimeout = wc;
exports.uuid = Y;
exports.uuid32bit = zc;
exports.uuidB32 = Bo;
exports.uuidB62 = Mo;
exports.uuidBytes = Ct;
exports.uuidDecode = Wn;
exports.uuidDecodeB32 = Oo;
exports.uuidDecodeB62 = Io;
exports.uuidDecodeV4 = Vo;
exports.uuidEncode = zo;
exports.uuidEncodeB32 = $o;
exports.uuidEncodeB62 = ko;
exports.uuidEncodeV4 = No;
exports.uuidIsValid = qc;
exports.uuidv4 = jo;
exports.valueToBoolean = Z;
exports.valueToFloat = ao;
exports.valueToInteger = so;
exports.valueToPath = ri;
exports.valueToString = xt;
exports.waitOn = Wa;
exports.walkSync = sr;
exports.walkSyncAsync = cr;
exports.writeText = Df;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=index.node.cjs.map